#!perl -W

use warnings;
use XML::LibXML;

my $top_srcdir=shift @ARGV;
$top_srcdir=".." if not defined $top_srcdir;

my$admsxml=XML::LibXML->new->parse_file("$top_srcdir/adms.xml")->getDocumentElement;
map{eval("sub x$_ {shift->getAttribute(\"$_\");}");} qw(name datatypefamily datatypename default info element attribute format);
my$admstpathxml=XML::LibXML->new->parse_file("$top_srcdir/admstpath.xml")->getDocumentElement;
map{eval("sub x$_ {shift->getAttribute(\"$_\");}");} qw(id label value ret linkto eparent regexp);
my$admstxml=XML::LibXML->new->parse_file("$top_srcdir/admst.xml")->getDocumentElement;
map{eval("sub x$_ {shift->getAttribute(\"$_\");}");} qw(haschild type);

my$BUILDER="\n/* ------- code automatically created by $0 -------------- */\n\n";
# build accessors for attribute
sub eparent
{
  my$element=shift;
  return $element->parentNode if($element->parentNode->nodeName eq "element");
}
sub xsize
{
  my$node=shift;
  return "list" if($node->nodeName eq "list");
  return "scalar";
}
sub uid  {my$e=shift;return if not $e;return $e->findnodes("uid/scalar|uid/list");}
sub attr {my$e=shift;return if not $e;return $e->findnodes("(uid/scalar)|(uid/list)|scalar|list");}
#svn
my$cygpath_top_srcdir=$top_srcdir;
if($cygpath_top_srcdir=`cygpath -ad $top_srcdir 2>/dev/null`)
{
  chomp $cygpath_top_srcdir;
  $cygpath_top_srcdir="\"$cygpath_top_srcdir\"";
}
my$SVN;
$SVN=`svnversion -n $cygpath_top_srcdir 2>/dev/null` or $SVN="unknown";
print "svn version: $SVN\n";
#parse adms.xml
my $EA;
my $EH;
my $EAH;
foreach($admsxml->findnodes("//element"))
{
  my$e=$_;
  push @$EA,$_;
  $EH->{&xname($_)}=$_;
  foreach($e->findnodes("uid/scalar|uid/list|scalar|list"))
  {
    $EAH{&xname($e)}{&xname($_)}=$_;
  }
}
#c-type
sub ctype
{
  my$xdatatypename=&xdatatypename($_);
  if(0) {}
  elsif($xdatatypename eq "basicenumeration") {return "admse"}
  elsif($xdatatypename eq "basicinteger")     {return "int"}
  elsif($xdatatypename eq "basicreal")        {return "double"}
  elsif($xdatatypename eq "basicstring")      {return "const char*"}
  elsif($xdatatypename eq "basickstring")     {return "const char*"}
  elsif($xdatatypename eq "basicfunction")    {return "void*"}
  else{return "p_$xdatatypename"}
}
sub ccontainer
{
  my$attribute=shift;
  return (&xsize($attribute) eq "list")?"p_slist":ctype($attribute);
}
sub hdece
{
  return &uid($_)?(join",",map{&ccontainer($_)." my".&xname($_)}&uid($_)):"void";
}
sub hdec
{
  return &uid($EH->{xdatatypename($_)})?(join",",map{&ctype($_)." my".&xname($_)}&uid($EH->{xdatatypename($_)})):"void";
}

my$adms_h;
$adms_h.=$BUILDER;
$adms_h.="#ifndef adms_h\n";
$adms_h.="#define adms_h\n";
$adms_h.="\n";
$adms_h.="#define SVN \"$SVN\" /* svn release version */\n";
$adms_h.=q@
/*headers -- depend on compiler, OS, ...*/
#  if defined(_MSC_VER)
#    define PACKAGE_NAME "adms"
#    if ! defined(PACKAGE_VERSION)
#      pragma message(__FILE__ ": warning: #warning undefined macro 'PACKAGE_VERSION' - defaulted to 'unknown'")
#      define PACKAGE_VERSION "unknown"
#    endif
#    define PACKAGE_STRING PACKAGE_NAME " " PACKAGE_VERSION
#    define PACKAGE_TARNAME PACKAGE_NAME
#    define PACKAGE_BUGREPORT "r29173\@users.sourceforge.net"
#    include <direct.h>
#    define isnan _isnan
#    define ADMS_PATH_SEPARATOR "\\\\"
#    define ADMS_F_OK 0
#    ifndef inline
#      define inline
#    endif
#    define HAVE_FLOAT_H 1
#    define HAVE_STDLIB_H 1 
#    define HAVE_PUTENV 1 
#    define HAVE_LOCALE 1 
#    define HAVE_STRING_H 1 
#    define HAVE_SYS_STAT_H 1
#    include <io.h>
#  else
#    include <config.h>
#    define ADMS_PATH_SEPARATOR "/"
#    include <unistd.h>
#    define ADMS_F_OK F_OK
#  endif
#  include <math.h>
#  if defined(HAVE_SYS_STAT_H)
#    include <sys/stat.h>
#  endif
#  if defined(HAVE_LOCALE_H)
#    include <locale.h>
#  endif
#  if defined(HAVE_FLOAT_H)
#    include <float.h>
#  endif
#  if defined(HAVE_UNISTD_H)
#    include <unistd.h>
#  endif
#  if defined(HAVE_STDLIB_H)
#    include <stdlib.h>
#  endif
#  if defined(HAVE_STRING_H)
#    include <string.h>
#  endif
#  include <assert.h>
#  include <signal.h>
#  include <stdarg.h>
#  include <stdio.h>
#  include <ctype.h>
#  include <errno.h>
#  include <time.h>
/* in case not Posix */
#  if defined(_S_IFDIR)
#    define ADMS_S_IFDIR _S_IFDIR
#  else 
#    define ADMS_S_IFDIR S_IFDIR
#  endif
/* check OS */
#  if defined(__CYGWIN__)
#    define ADMS_OS_MS
#    define ADMS_OS_MSCYGWIN
#    define ADMS_OS "MSCYGWIN"
#  elif defined(__MSDOS__)
#    define ADMS_OS_MS
#    define ADMS_OS_MSDOS
#    define ADMS_OS "MSDOS"
#  elif defined(_WIN64)
#    define ADMS_OS_MS
#    define ADMS_OS_MSWIN64
#    define ADMS_OS "MSWIN64"
#  elif defined(_WIN32)
#    define ADMS_OS_MS
#    define ADMS_OS_MSWIN32
#    define ADMS_OS "MSWIN32"
#  else
#    define ADMS_OS_UNKNOWN
#    define ADMS_OS "UNKNOWN"
#  endif
/* check compiler */
#  if defined(__MINGW32__)
#    ifndef WIN32
#      define WIN32
#    endif
#    define ADMS_COMPILER_MINGCC
#    define ADMS_COMPILER "MINGCC"
#  elif defined(__CYGWIN__)
#    ifndef WIN32
#      define WIN32
#    endif
#    define ADMS_COMPILER_GCC 
#    define ADMS_COMPILER "GCC" 
#  elif defined(_MSC_VER)
#    ifndef WIN32
#      define WIN32
#    endif
#    define ADMS_COMPILER_MSVC
#    define ADMS_COMPILER "MSVC"
#  else
#    define ADMS_COMPILER_CC
#    define ADMS_COMPILER "CC"
#  endif
@;
#c macros
$adms_h.="#define E\\\n";
map{$adms_h.="  EE(".xname($_).")\\\n";} @$EA;
$adms_h.="/*fin*/\n\n";
$adms_h.="#define A\\\n";
map{my$e=xname($_);map{$adms_h.="  AA(".xname($_).")\\\n";} &attr($_);} @$EA;
$adms_h.="/*fin*/\n\n";
my%ALIAS;
my%ALIASBIS;
$adms_h.="#define ALIAS\\\n";
map{my$e=&xname($_);
  map{
       push @{$ALIAS{&xname($_)}},[$e,&xelement($_)];
       $adms_h.="  AALIAS($e,".&xname($_).",".&xelement($_).",".&xattribute($_).")\\\n";
     } $_->findnodes("alias");} @$EA;
map{my$e=&xname($_);map{push @{$ALIASBIS{&xname($_)}},[$e,&xelement($_),&xattribute($_)];} $_->findnodes("aliasbis");} @$EA;
$adms_h.="/*fin*/\n\n";

#va elements
$adms_h.="#define VA\\\n";
map{$adms_h.="  VVA(".xname($_).")\\\n" if vla(xname($_));} @$EA;
$adms_h.="/*fin*/\n\n";

#elements + attributes
$adms_h.="#define EA\\\n";
map{my$e=xname($_);map{$adms_h.="  EEA(".$e.",".xname($_).")\\\n";} &attr($_);} @$EA;
$adms_h.="/*fin*/\n\n";

#va elements + attributes
$adms_h.="#define EAVA\\\n";
map{my$e=xname($_);map{$adms_h.="  EEAVA(".$e.",".xname($_).")\\\n";} &attr($_) if vla($e);} @$EA;
$adms_h.="/*fin*/\n\n";

$adms_h.="#define TK\\\n";
#add tokens for pparse
#look for //[@name=pparse]/scalar/attribute[@name=tkid]
my@token;
#element
map{push @token,xname($_);} @$EA;
#attribute
map{map{push @token,xname($_);} $_->findnodes("uid/scalar|uid/list|scalar|list");} @$EA;
#enum
map{map{push @token,xname($_);} $_->findnodes("uid/scalar/evalue|scalar/evalue");} @$EA;
push @token,qw(past_name datatypefamily absolute basicenumeration basicinteger basicreal basicstring basiclist empty);
my@tokenname;
my%seentokenname;
map{$adms_h.="  TTK($_)\\\n" if not defined $seentokenname{$_};$seentokenname{$_}=1;} @token;
$adms_h.="/*fin*/\n\n";

#lexer
my$tk;
map{$tk.="  tktk_".xid($_).",\n";} $admstpathxml->findnodes("//constant");
map{map{$tk.="  tktk_".$_.",\n";}split " ", xid($_);} $admstpathxml->findnodes("//regexp");
$adms_h.=qq@
#undef TTK
#define TTK(tk) admse_##tk,
typedef enum {
  admse__zero=0,
  admse__any,
  admse__constant,
  admse__p, /*%p*/
  admse__s, /*%s*/
  admse__path,
  admse__arguments,
  admse__croix,
  admse__croixcroix,
  admse__elist,
  admse__eelist,
  TK
#ifndef tktk_notequal
$tk
#endif
  admse__
} admse;
@;
$adms_h.="#undef win32_interface\n";
$adms_h.="#if defined(WIN32)\n";
$adms_h.="#  if defined(insideElement)\n";
$adms_h.="#    define win32_interface __declspec(dllexport)\n";
$adms_h.="#  else\n";
$adms_h.="#    define win32_interface __declspec(dllimport)\n";
$adms_h.="#  endif\n";
$adms_h.="#else\n";
$adms_h.="#  define win32_interface extern\n";
$adms_h.="#endif\n";
$adms_h.="\n";
foreach(@$EA)
{
  my$ename=xname($_);
  $adms_h.="typedef struct s_$ename  t_$ename;\n";
  $adms_h.="typedef t_$ename*        p_$ename;\n";
  $adms_h.="typedef const p_$ename   p_k$ename;\n";
}

#miscH
$adms_h.="win32_interface FILE *stdadmstdbgimpl;\n";
$adms_h.="#define stdadmstdbg (stdadmstdbgimpl?stdadmstdbgimpl:stderr)\n";
$adms_h.="win32_interface int admsmain(const char*xcode,const char*xflag,const char*vacode);\n";
$adms_h.="win32_interface int adms_global_nbadmstnew(void);\n";
$adms_h.="win32_interface int adms_global_nbadmstdestroy(void);\n";
$adms_h.="win32_interface void adms_global_increment_nbadmstnew(void);\n";
$adms_h.="win32_interface void adms_global_increment_nbadmstdestroy(void);\n";
$adms_h.="\n/*-- Miscellaneous routines --*/\n";
$adms_h.=q@
win32_interface const double adms_dzero;
win32_interface double adms_NAN;
win32_interface p_admst aread (p_admst myadmst);
win32_interface void deref(p_admst mystack);
win32_interface int admstpathparse ();
win32_interface void postpath (p_path mypath);
win32_interface void dbpath (p_path mypath);
win32_interface void dbtext (p_text mytext);
win32_interface p_text tparse (p_ktransform mytransform,const char* aname,const char* avalue);
win32_interface p_path pparse (p_transform mytransform,const char* aname,const char* avalue);
union admsu
{
  int i;
  double r;
  char* s;
  p_adms p;
};
win32_interface const int minusone;
typedef struct s_slist t_slist;
typedef t_slist* p_slist;
typedef void (*_p_cbcondition) (p_path mypath,p_admst myadmst);
win32_interface void free_ptraverse (p_ptraverse p);
win32_interface int retposition (p_admst myadmst,int offset);
win32_interface p_ptraverse ptraverse (p_admst dot,p_path mypath0);
win32_interface char* tsprintf (p_kadmst myadmst, p_ktext mytext);
win32_interface int adms_strtol (p_ktransform mytransform,const char* mynumber);
win32_interface double adms_strtod (p_ktransform mytransform,const char* myreal);
win32_interface void bp(void);
win32_interface char*adms_integertostring(int value);
win32_interface char*adms_doubletostring(double value);
win32_interface int adms_setenv(const char* myname,const char* myvalue);
win32_interface int adms_file_isregular(const char* myfilename);
win32_interface int adms_file_isdirectory(const char* myfilename);
win32_interface p_slist adms_slist_new (p_adms d);
win32_interface p_slist adms_slist_copy (p_slist l);
win32_interface void adms_slist_concat (p_slist* l1,p_slist l2);
win32_interface p_slist adms_slist_find (p_slist l,p_kadms data);
win32_interface void adms_slist_free (p_slist l);
win32_interface int adms_slist_index (p_slist l, p_kadms data);
win32_interface p_slist adms_slist_last (p_slist l);
win32_interface unsigned int adms_slist_length (p_slist l);
win32_interface p_slist adms_slist_nth (p_slist l,unsigned int  n);
win32_interface p_adms adms_slist_nth_data (p_slist l,unsigned int n);
win32_interface void adms_slist_print(const char* message,p_slist l);
win32_interface p_adms adms_slist_pull(p_slist* l);
win32_interface void adms_slist_push(p_slist* l,p_adms data);
win32_interface p_slist adms_slist_reverse (p_slist l);
win32_interface void adms_slist_inreverse (p_slist* l);
struct s_slist
{
  p_adms data;
  p_slist next;
};
@;
$adms_h.=q[

win32_interface p_admsmain root(void);
win32_interface void rootnew(p_admsmain myglobaladmsmain);

typedef p_admst (t_new) (p_ktransform mytransform,p_admst dot,p_slist arguments[],const int size);
typedef p_admst (*p_new) (p_ktransform mytransform,p_admst dot,p_slist arguments[],const int size);
#define _t_new(function) p_admst (function) (p_ktransform mytransform,p_admst dot,p_slist arguments[],const int size)

typedef int (t_cmp) (p_adms myadms, p_adms myadmsref);
typedef int (*p_cmp) (p_adms myadms, p_adms myadmsref);
#define _t_cmp(function) int (function) (p_adms myadms, p_adms myadmsref)

/*-- Messaging --*/
typedef void (t_message) (const char*format, ...);
typedef void (*p_message) (const char*format, ...);
#define _t_message(function)  void (function) (const char*format, ...)

win32_interface void adms_toupper(char*m);
win32_interface void adms_tolower(char*m);
win32_interface char*adms_kclone(const char* m);
win32_interface char*adms_knclone(const char* m,const int l);
win32_interface char*adms_m2nclone(const char* m,const char* n);
win32_interface void adms_strconcat(char **s1,char *s2);
win32_interface void adms_k2strconcat(char **s1,const char* s2);
win32_interface FILE *adms_file_open_read (const char* fileName);
];
my@message=(
  ["info","stdout",0],
  ["usage","stdout",0],
  ["verbose","stdout",0],
  ["debug","stdout",0],
  ["dbg_vla","stdout",0],
  ["dbg_xml","stdout",0],
  ["dbg_mem","stdout",0],
  ["hint","stderr",0],
  ["warning","stderr",0],
  ["obsolete","stderr",0],
  ["error","stderr",2],
  ["fatal","stderr",1],
  ["admstdbg","stdadmstdbg",-1]
);
foreach my$mess(@message)
{
  my$name=$mess->[0];
  $adms_h.="win32_interface t_message adms_message_${name}_impl;\n";
  $adms_h.="win32_interface t_message adms_message_${name}_continue_impl;\n";
  $adms_h.="#define adms_message_$name(VAARGS)\\\n";
  $adms_h.="{\\\n";
  $adms_h.="  if((root())\\\n";
  $adms_h.="    &&(root()->_$name==admse_yes))\\\n";
  $adms_h.="    adms_message_${name}_impl VAARGS;\\\n";
  $adms_h.="}\n";
  $adms_h.="#define adms_message_${name}_continue(VAARGS)\\\n";
  $adms_h.="{\\\n";
  $adms_h.="  if((root())\\\n";
  $adms_h.="    &&(root()->_$name==admse_yes))\\\n";
  $adms_h.="    adms_message_${name}_continue_impl VAARGS;\\\n";
  $adms_h.="}\n";
}
$adms_h.="\n";
$adms_h.="win32_interface char* aprintf (p_ktransform mytransform,p_kadmst myadmst);\n";
sub vla {my$e=shift; return !(($e eq "return")||($e eq "adms")||($e eq "yaccval")||($e eq "admst")||($e eq "transform")
||($e eq "itransform")||($e eq "admstvariable")||($e eq "pparse")||($e eq "ptraverse")||($e eq "text")||($e eq "path"));}
foreach(@$EA)
{
  my$element=$_;
  my$ename=$element->getAttribute("name");
  $adms_h.="\n/* ------- $ename -------------- */\n";
  my$parent=&eparent($element);
  $adms_h.="#define adms_$ename(member) ((p_$ename)(member))\n";
  #mkstruct
  $adms_h.="struct s_$ename {\n";
  if($parent)
  {
    my$parentName=$parent->getAttribute ("name");
    $adms_h.="  t_$parentName _$parentName;\n";
  }
  foreach(&attr($element))
  {
    my$xname=&xname($_);
    if(($ename eq "admst")&&($xname eq "item"))
    {
      $adms_h.="  union admsu _item;\n";
    }
    elsif(($xname eq "datatypename")||($xname eq "pseudo"))
    {
      $adms_h.="  admse _${xname};\n";
    }
    else
    {
      my$ctype=ccontainer($_);
      $ctype=~s/const // if(&xdatatypename($_) eq "basicstring");
      $adms_h.="  $ctype _$xname;\n";
      $adms_h.="  int _${xname}_isdefault : 2;\n" if vla($ename);
    }
  }
  $adms_h.="};\n";
  #uid
  $adms_h.="win32_interface char*adms_${ename}_uid (p_$ename my$ename);\n";
  if($ename ne "adms")
  {
    $adms_h.="win32_interface p_$ename adms_${ename}_new(".&hdece($_).");\n";
    $adms_h.="win32_interface void adms_${ename}_free(p_$ename my$ename);\n";
  }
  foreach(&attr($element))
  {
    #valueto
    my$xname=&xname($_);
    my$xdatatypename=&xdatatypename($_);
    $adms_h.="win32_interface void adms_${ename}_valueto_$xname (p_$ename my$ename,".ccontainer($_)." _${xname});\n";
    next if xsize($_) eq "scalar";
    #prepend
    if(($ename eq "module")&&($xname =~ "branch|node|probe|source"))
    {
      $adms_h.="win32_interface ".ctype($_)." adms_${ename}_list_${xname}_prepend_by_id_once_or_ignore (p_$ename mymy${ename},".&hdec($_).");\n";
    }
    if(
      (($ename =~ "admsmain")&&($xname =~ "module|nature"))
      ||
      (($ename =~ "module")&&($xname =~ "branchalias|instance|node|nodealias|range"))
    )
    {
      $adms_h.="win32_interface ".ctype($_)." adms_${ename}_list_${xname}_prepend_by_id_once_or_abort (p_$ename mymy${ename},".&hdec($_).");\n";
    }
    if(
      (($ename =~ "admsmain")&&($xname =~ "discipline"))
      ||
      (($ename =~ "analogfunction|block|module")&&($xname =~ "variable"))
      ||
      (($ename =~ "instance")&&($xname =~ "parameterset|terminal"))
      ||
      (($ename =~ "module")&&($xname =~ "analogfunction"))
      ||
      (($ename =~ "variable")&&($xname =~ "alias"))
    )
    {
      $adms_h.="win32_interface void adms_${ename}_list_${xname}_prepend_once_or_abort (p_$ename mymy${ename},".ctype($_)." my${xname});\n";
    }
    next if $xdatatypename eq "adms";
    my@cmp;
    foreach(&uid($EH->{$xdatatypename}))
    {
      my$cur="ref$xdatatypename->_".&xname($_);
      my$ref="my".&xname($_);
      if(xdatatypename($_) eq "basicstring")
      {
        push @cmp,"!strcmp($cur,$ref)";
      }
      elsif(&xdatatypename($_) eq "lexval")
      {
        push @cmp,"!strcmp($cur->_string,$ref->_string)";
      }
      elsif(&xdatatypename($_) eq "quark")
      {
        push @cmp,"!strcmp($cur->_value,$ref->_value)";
      }
      else
      {
        push @cmp,"($cur==$ref)";
      }
    }
    #lookup
    if(
      (($ename =~ "admsmain")&&($xname =~ "discipline"))
      ||
      (($ename =~ "admsmain")&&($xname =~ "module"))
      ||
      (($ename =~ "admsmain")&&($xname =~ "nature"))
      ||
      (($ename =~ "analogfunction")&&($xname =~ "variable"))
      ||
      (($ename =~ "module")&&($xname =~ "branchalias"))
      ||
      (($ename =~ "module")&&($xname =~ "node"))
      ||
      (($ename =~ "module")&&($xname =~ "variable"))
    )
    {
      $adms_h.="win32_interface ".ctype($_)." adms_${ename}_list_${xname}_lookup_by_id (p_$ename mymy$ename,".&hdec($_).");\n";
    }
  }
}
$adms_h.="
win32_interface admse ns_strtoe (const char* tk);
win32_interface char* ns_etostr (admse e);
win32_interface p_new adms_admsxml_new (p_ktransform mytransform,const char* ename);
win32_interface p_cmp adms_admsxml_cmp (p_kadmst myadmst);
#endif /* adms_h */\n";

open FILE,">$top_srcdir/admsXml/adms.h"; print FILE $adms_h; close FILE;
print "$top_srcdir/admsXml/adms.h: created\n";

sub pnew
{
  my$leaf=shift;
  my$leafpath=shift;
  my$element=shift;
  my$parent=shift;
  my$pname=$parent->getAttribute("name");
  my$pelement=$EH->{$pname};
  my$supersuperElement=&eparent($pelement);
  my$code;
  if($supersuperElement)
  {
    $code.=&pnew($leaf,"${leafpath}_$pname.",$pelement,$supersuperElement);
  }
  foreach(&attr($pelement))
  {
    my$xname=&xname($_);
    my$xdatatypename=&xdatatypename($_);
    my$xdefault=&xdefault($_);
    next if not $xdefault;
    if($xdefault=~/^@/)
    {
      $xdefault=~s/@//;
      $code="  ${leafpath}_$pname._$xname=admse_".$leaf->getAttribute($xdefault).";\n";
    }
    elsif($xdatatypename eq "basicreal")
    {
      $code.="  ${leafpath}_$pname._$xname=$xdefault;\n";
    }
    elsif($xdatatypename eq "basicenumeration")
    {
      $code.="  ${leafpath}_$pname._$xname=admse_$xdefault;\n";
    }
    else {die;}
  }
  return $code;
}

sub mkfree ()
{
  my$element=$_;
  my$ename=$element->getAttribute("name");
  my$code;
  $code.="void adms_${ename}_free(p_$ename my$ename)\n";
  $code.="{\n";
  $code.="  if(!my$ename)\n";
  $code.="    return;\n";
  my$parent;
  foreach(&attr($element))
  {
    if(xsize($_) eq "list")
    {
      $code.="  adms_slist_free(my$ename->_".&xname($_).");\n";
    }
    elsif(xdatatypename($_) eq "basicstring")
    {
      $code.="  free(my$ename->_".xname($_).");\n";
    }
  }
  $code.="  adms_global_increment_nbadmstdestroy();\n" if $ename eq "admst";
  $code.="  free(my$ename);\n";
  $code.="}\n";
  return $code;
}

sub mkuid ()
{
  my$element=$_;
  my$ename=$element->getAttribute("name");
  my$code;
  my$format=$element->findnodes("uid")->get_node(0)->getAttribute ("format");
  $code.="char*adms_${ename}_uid (p_$ename mynew$ename)\n";
  $code.="{\n";
  $code.="  char*myuid=NULL;\n";
  my@Attr=&attr($element);
  $code.="  adms_k2strconcat(&myuid,\"\");\n" if not $format;
  while($format=~s/^([^\$]*)\$(\d)//)
  {
    $code.="  adms_k2strconcat(&myuid,\"$1\");\n" if $1;
    my$attr=$Attr[$2-1];
    die "$ename: $format" if not defined $attr;
    my$xname=&xname($attr);
    my$xfamily=&xdatatypefamily($attr);
    my$xdatatypename=&xdatatypename($attr);
    my$xsize=&xsize($attr);
    if($xsize eq "list")
    {
      my$subformat=&xformat($attr);
      $code.="  {\n";
      $code.="    p_slist list=mynew$ename->_$xname;\n";
      $code.="    while(list)\n";
      $code.="    {\n";
      $code.="      adms_strconcat(&myuid,adms_admsxml_uid(list->data));\n";
      $code.="      if(list->next) adms_k2strconcat(&myuid,\"$subformat\");\n";
      $code.="      list=list->next;\n";
      $code.="    }\n";
      $code.="  }\n";
    }
    elsif($xdatatypename eq "basicenumeration")
    {
      foreach(@{$attr->findnodes("evalue")})
      {
        my$enode=$_;
        $code.="  if(mynew$ename->_$xname==admse_".&xname($enode).")\n";
        $code.="  {\n";
        my$enuminfo=&xinfo($enode);
        while($enuminfo=~s/([^\$]*)\$(\d+)//)
        {
          my$v=&xname($Attr[$2-1]);
          $code.="    adms_k2strconcat(&myuid,\"$1\");\n";
          $code.="    adms_strconcat(&myuid,adms_admsxml_uid(mynew$ename->_$v));\n";
        }
        $code.="    adms_k2strconcat(&myuid,\"$enuminfo\");\n";
        $code.="  }\n";
      }
    }
    elsif($xdatatypename eq "basicinteger")
    {
      $code.="  adms_strconcat(&myuid,adms_integertostring(mynew$ename->_$xname));\n";
    }
    elsif($xdatatypename eq "basicreal")
    {
      $code.="  adms_strconcat(&myuid,adms_doubletostring(mynew$ename->_$xname));\n";
    }
    elsif($xdatatypename eq "basicstring")
    {
      $code.="  adms_k2strconcat(&myuid,mynew$ename->_$xname);\n";
    }
    elsif($xdatatypename eq "adms")
    {
      $code.="  adms_strconcat(&myuid,adms_admsxml_uid(mynew$ename->_$xname));\n";
    }
    elsif($xfamily eq "reference")
    {
      $code.="  adms_strconcat(&myuid,adms_${xdatatypename}_uid(mynew$ename->_$xname));\n";
    }
  }
  $code.="  adms_k2strconcat(&myuid,\"$format\");\n" if $format;
  $code.="  return myuid;\n";
  $code.="}\n";
  return $code;
}

my$adms_c;
$adms_c.=$BUILDER;
$adms_c.="#include \"adms.h\"\n";
$adms_c.="const double adms_dzero=0.0;\n";
$adms_c.="double adms_NAN;\n";

#enumeration to string 
$adms_c.="FILE *stdadmstdbgimpl=NULL;\n";
$adms_c.="#undef TTK\n";
$adms_c.="#define TTK(tk) if(e==admse_##tk) return #tk;\n";
$adms_c.="char* ns_etostr (admse e)\n";
$adms_c.="{\n";
$adms_c.="  TK\n";
$adms_c.="  return NULL;\n";
$adms_c.="}\n";

#string to enumeration
$adms_c.="#undef TTK\n";
$adms_c.="#define TTK(tk) if(!strcmp(mytk,#tk)) return admse_##tk;\n";
$adms_c.="admse ns_strtoe (const char* mytk)\n";
$adms_c.="{\n";
$adms_c.="  TK\n";
$adms_c.="  return 0;\n";
$adms_c.="}\n";

$adms_c.="static char* adms_admsxml_uid (p_kadms myitem)\n";
$adms_c.="{\n";
$adms_c.="  if(!myitem)\n";
$adms_c.="    return adms_kclone(\"\");\n";
foreach(@$EA)
{
  my$ename=xname($_);
  next if $ename eq "adms";
  $adms_c.="  if(myitem->_datatypename==admse_$ename)\n";
  $adms_c.="    return adms_${ename}_uid((p_$ename)myitem);\n";
}
$adms_c.="  adms_message_fatal_continue((\"%s:%i: internal error - should not be reached\\n\",__FILE__,__LINE__))\n";
$adms_c.="  adms_message_fatal((\"%s:%i: please report to r29173\@users.sourceforge.net\\n\",__FILE__,__LINE__))\n";
$adms_c.="  return NULL;\n";
$adms_c.="}\n";
$adms_c.="char* aprintf (p_ktransform mytransform,p_kadmst myadmst)\n";
$adms_c.="{\n";
$adms_c.="  if(myadmst->_pseudo==admse__elist)\n";
$adms_c.="  {\n";
$adms_c.="    adms_message_fatal_continue((\"list not supported\\n\"))\n";
$adms_c.="    adms_message_fatal((\"see %s\\n\",adms_transform_uid(mytransform)))\n";
$adms_c.="  }\n";
$adms_c.="  if(myadmst->_pseudo==admse_empty)\n";
$adms_c.="    return adms_kclone(\"\");\n";
$adms_c.="  if(myadmst->_pseudo==admse_datatypename)\n";
$adms_c.="    return adms_kclone(ns_etostr((admse)myadmst->_item.i));\n";
$adms_c.="  if(myadmst->_pseudo==admse_basicenumeration)\n";
$adms_c.="    return adms_kclone(ns_etostr((admse)myadmst->_item.i));\n";
$adms_c.="  if(myadmst->_pseudo==admse_basicinteger)\n";
$adms_c.="    return adms_integertostring(myadmst->_item.i);\n";
$adms_c.="  if(myadmst->_pseudo==admse_basicreal)\n";
$adms_c.="    return adms_doubletostring(myadmst->_item.r);\n";
$adms_c.="  if(myadmst->_pseudo==admse_basicstring)\n";
$adms_c.="    return adms_kclone((char*)myadmst->_item.s);\n";
$adms_c.="  if(myadmst->_pseudo==admse__croix)\n";
$adms_c.="  {\n";
$adms_c.="    if(((p_attribute)myadmst->_item.p)->_value)\n";
$adms_c.="      return aprintf(mytransform,(p_admst)((p_attribute)myadmst->_item.p)->_value);\n";
$adms_c.="    else\n";
$adms_c.="      return adms_kclone(\"\");\n";
$adms_c.="  }\n";
foreach(@$EA)
{
  my$ename=xname($_);
  next if $ename eq "adms";
  $adms_c.="  if(myadmst->_pseudo==admse_$ename)\n";
  $adms_c.="    return adms_${ename}_uid(adms_$ename(myadmst->_item.p));\n";
}
$adms_c.="  adms_message_fatal_continue((\"%s:%i: internal error - should not be reached\\n\",__FILE__,__LINE__))\n";
$adms_c.="  adms_message_fatal_continue((\"%s:%i: please report to r29173\@users.sourceforge.net\\n\",__FILE__,__LINE__))\n";
$adms_c.="  adms_message_fatal((\"see %s\\n\",adms_transform_uid(mytransform)))\n";
$adms_c.="  return NULL;\n";
$adms_c.="}\n";

$adms_c.=q@
const int minusone=-1;
void deref(p_admst myadmst)
{
  myadmst->_refd--;
  if(myadmst->_refd)
    return;
  if(myadmst->_ori)
    deref(myadmst->_ori);
  if((myadmst->_hasnewbasicstring==1)&&(myadmst->_pseudo==admse_basicstring))
    free(myadmst->_item.s);
  adms_admst_free(myadmst);
}
#define adms_basicinteger(e) ((int)e)
#define adms_basicreal(e) ((double)e)
#define adms_basicstring(e) ((char*)e)
#define adms_basicstring_uid(e) ((char*)e)
static p_admst adms_basicenumeration_xnew (p_ktransform mytransform,p_admst dot,p_slist myinputs[],const int size)
{
  if(size!=1)
  {
    adms_message_fatal_continue(("admst:new(basicenumeration) bad number of inputs (found %i, expected 1)\n",size))
    adms_message_fatal(("see %s\n",adms_transform_uid(mytransform)))
    return NULL;
  }
  else if(adms_slist_length(myinputs[0])!=1)
  {
    adms_message_fatal_continue(("admst:new(basicenumeration) bad number of element in inputs[0] (found %i, expected 1)\n",adms_slist_length(myinputs[0])))
    adms_message_fatal(("see %s\n",adms_transform_uid(mytransform)))
    return NULL;
  }
  else
  {
    p_admst myadmst=adms_admst_new(dot);
    char*s=aprintf(mytransform,(p_admst)(myinputs[0]->data));
    myadmst->_item.i=adms_strtol(mytransform,s);
    free(s);
    deref((p_admst)myinputs[0]->data);
    adms_slist_free(myinputs[0]);
    myadmst->_pseudo=admse_basicinteger;
    return myadmst;
  }
}
static p_admst adms_basicinteger_xnew (p_ktransform mytransform,p_admst dot,p_slist myinputs[],const int size)
{
  if(size!=1)
  {
    adms_message_fatal_continue(("admst:new(basicinteger) bad number of inputs (found %i, expected 1)\n",size))
    adms_message_fatal(("see %s\n",adms_transform_uid(mytransform)))
    return NULL;
  }
  else if(adms_slist_length(myinputs[0])!=1)
  {
    adms_message_fatal_continue(("admst:new(basicinteger) bad number of element in inputs[0] (found %i, expected 1)\n",adms_slist_length(myinputs[0])))
    adms_message_fatal(("see %s\n",adms_transform_uid(mytransform)))
    return NULL;
  }
  else
  {
    p_admst myadmst=adms_admst_new(dot);
    char*s=aprintf(mytransform,(p_admst)(myinputs[0]->data));
    myadmst->_item.i=adms_strtol(mytransform,s);
    free(s);
    deref((p_admst)myinputs[0]->data);
    adms_slist_free(myinputs[0]);
    myadmst->_pseudo=admse_basicinteger;
    return myadmst;
  }
}
static p_admst adms_basicreal_xnew (p_ktransform mytransform,p_admst dot,p_slist myinputs[],const int size)
{
  if(size!=1)
  {
    adms_message_fatal_continue(("admst:new(basicreal) bad number of inputs (found %i, expected 1)\n",size))
    adms_message_fatal(("see %s\n",adms_transform_uid(mytransform)))
    return NULL;
  }
  else if(adms_slist_length(myinputs[0])!=1)
  {
    adms_message_fatal_continue(("admst:new(basicreal) bad number of element in inputs[0] (found %i, expected 1)\n",adms_slist_length(myinputs[0])))
    adms_message_fatal(("see %s\n",adms_transform_uid(mytransform)))
    return NULL;
  }
  else
  {
    p_admst myadmst=adms_admst_new(dot);
    char*s=aprintf(mytransform,(p_admst)(myinputs[0]->data));
    myadmst->_item.r=adms_strtod(mytransform,s);
    free(s);
    deref((p_admst)myinputs[0]->data);
    adms_slist_free(myinputs[0]);
    myadmst->_pseudo=admse_basicreal;
    return myadmst;
  }
}
static p_admst adms_basicstring_xnew (p_ktransform mytransform,p_admst dot,p_slist myinputs[],const int size)
{
  if(size!=1)
  {
    adms_message_fatal_continue(("admst:new(basicstring) bad number of inputs (found %i, expected 1)\n",size))
    adms_message_fatal(("see %s\n",adms_transform_uid(mytransform)))
    return NULL;
  }
  else if(adms_slist_length(myinputs[0])!=1)
  {
    adms_message_fatal_continue(("admst:new(basicstring) bad number of element in inputs[0] (found %i, expected 1)\n",adms_slist_length(myinputs[0])))
    adms_message_fatal(("see %s\n",adms_transform_uid(mytransform)))
    return NULL;
  }
  else
  {
    p_admst myadmst=adms_admst_new(dot);
    char*s=aprintf(mytransform,(p_admst)(myinputs[0]->data));
    deref((p_admst)myinputs[0]->data);
    adms_slist_free(myinputs[0]);
    myadmst->_item.s=s;
    myadmst->_pseudo=admse_basicstring;
    return myadmst;
  }
}
static int adms_basicenumeration_cmp (const char* mybasicenumeration,const char* refbasicenumeration)
{
  return (mybasicenumeration!=refbasicenumeration);
}
static int adms_basicinteger_cmp (const char* mybasicinteger,const char* refbasicinteger)
{
  return (mybasicinteger!=refbasicinteger);
}
static int adms_basicreal_cmp (const char* mybasicreal,const char* refbasicreal)
{
  return ((mybasicreal-refbasicreal)<0)||((mybasicreal-refbasicreal)>0);
}
static int adms_basicstring_cmp (const char* mybasicstring,const char* refbasicstring)
{
  return (strcmp(mybasicstring,refbasicstring));
}
@;
foreach(@$EA)
{
  my$ename=xname($_);
  next if not vla($ename);
  #cmp
  $adms_c.="static int adms_${ename}_cmp (p_$ename my$ename,p_$ename ref$ename)\n";
  $adms_c.="{\n";
  $adms_c.="  return\n";
  $adms_c.="  (\n";
  my$isfirst="    ";
  foreach(&uid($_))
  {
    my$xname=&xname($_);
    my$xdatatypename=&xdatatypename($_);
    if($xdatatypename eq "basicstring")
    {
      $adms_c.="${isfirst}strcmp(my$ename->_".&xname($_).",ref$ename->_".&xname($_).")";
      $isfirst="\n    ||\n    ";
    }
    elsif($xdatatypename eq "basicstring")
    {
      $adms_c.="${isfirst}strcmp(my$ename->_".&xname($_)."->_string,ref$ename->_".&xname($_)."->_string)";
      $isfirst="\n    ||\n    ";
    }
    elsif($xdatatypename eq "quark")
    {
      $adms_c.="${isfirst}strcmp(my$ename->_".&xname($_)."->_value,ref$ename->_".&xname($_)."->_value)";
      $isfirst="\n    ||\n    ";
    }
    elsif($xdatatypename eq "lexval")
    {
      $adms_c.="${isfirst}strcmp(my$ename->_".&xname($_)."->_string,ref$ename->_".&xname($_)."->_string)";
      $isfirst="\n    ||\n    ";
    }
    else
    {
      $adms_c.="$isfirst(my$ename->_".&xname($_)." != ref$ename->_".&xname($_).")";
      $isfirst="\n    ||\n    ";
    }
  }
  $adms_c.=$isfirst."1" if not &uid($_);
  $adms_c.="\n  );\n";
  $adms_c.="}\n";
}
foreach(@$EA)
{
  my$ename=xname($_);
  $adms_c.="\n/* ------- $ename -------------- */\n";
  $adms_c.=&mkfree($_);
  foreach(&attr($_))
  {
    #valueto
    my$xname=&xname($_);
    my$xdatatypename=&xdatatypename($_);
    $adms_c.="\nvoid adms_${ename}_valueto_$xname (p_$ename my$ename,".ccontainer($_)." _${xname})\n{\n";
#fixme: other basic?
    if(($xdatatypename eq "basicstring")&&(xsize($_) eq "scalar"))
    {
      $adms_c.="  my$ename->_$xname=adms_kclone(_$xname);\n";
    }
    elsif(($ename eq "admst")&&($xname eq "item"))
    {
      $adms_c.="  /*fixme: my$ename->_$xname=_$xname;*/\n";
    }
    else
    {
      $adms_c.="  my$ename->_$xname=_$xname;\n";
    }
    $adms_c.="  my$ename->_${xname}_isdefault=0;\n" if vla($ename);
    $adms_c.="}\n";
    next if xsize($_) eq "scalar";
    #prepend
    my$cdec=join",",map{"my".&xname($_)}&uid($EH->{xdatatypename($_)});
    if(($ename eq "module")&&($xname =~ "branch|node|probe|source"))
    {
      $adms_c.=ctype($_)." adms_${ename}_list_${xname}_prepend_by_id_once_or_ignore (p_$ename mymy${ename},".&hdec($_).")\n";
      $adms_c.="{\n";
      $adms_c.="  p_slist list=mymy$ename->_$xname;\n";
      $adms_c.="  ".ctype($_)." ref${xname}=adms_${xdatatypename}_new($cdec);\n";
      $adms_c.="  while(list)\n";
      $adms_c.="  {\n";
      $adms_c.="    if(!adms_${xdatatypename}_cmp((p_$xdatatypename)list->data,ref${xname}))\n";
      $adms_c.="    {\n";
      $adms_c.="      adms_${xdatatypename}_free (ref$xname);\n";
      $adms_c.="      return (p_$xdatatypename)list->data;\n";
      $adms_c.="    }\n";
      $adms_c.="    list=list->next;\n";
      $adms_c.="  }\n";
      $adms_c.="  adms_slist_push(&mymy$ename->_$xname,(p_adms)ref$xname);\n";
      $adms_c.="  return ref$xname;\n";
      $adms_c.="}\n";
    }
    if(
      (($ename =~ "admsmain")&&($xname =~ "module|nature"))
      ||
      (($ename =~ "module")&&($xname =~ "branchalias|instance|node|nodealias|range"))
    )
    {
      $adms_c.=ctype($_)." adms_${ename}_list_${xname}_prepend_by_id_once_or_abort (p_$ename mymy${ename},".&hdec($_).")\n";
      $adms_c.="{\n";
      $adms_c.="  p_slist list=mymy${ename}->_${xname};\n";
      $adms_c.="  ".ctype($_)." ref${xname}=adms_${xdatatypename}_new($cdec);\n";
      $adms_c.="  while(list)\n";
      $adms_c.="  {\n";
      $adms_c.="    if(!adms_${xdatatypename}_cmp(adms_${xdatatypename}(list->data),ref${xname}))\n";
      $adms_c.="    {\n";
      $adms_c.="      adms_message_fatal((\"${ename}=[%s] ${xname}=[%s] already defined\\n\",\n";
      $adms_c.="        adms_${ename}_uid(mymy${ename}),adms_${xdatatypename}_uid(ref${xname})))\n";
      $adms_c.="      adms_${xdatatypename}_free (ref${xname});\n";
      $adms_c.="    }\n";
      $adms_c.="    list=list->next;\n";
      $adms_c.="  }\n";
      $adms_c.="  adms_slist_push(&mymy${ename}->_${xname},(p_adms)ref$xname);\n";
      $adms_c.="  return ref${xname};\n";
      $adms_c.="}\n";
    }
    if(
      (($ename =~ "admsmain")&&($xname =~ "discipline"))
      ||
      (($ename =~ "analogfunction|block|module")&&($xname =~ "variable"))
      ||
      (($ename =~ "instance")&&($xname =~ "parameterset|terminal"))
      ||
      (($ename =~ "module")&&($xname =~ "analogfunction"))
      ||
      (($ename =~ "variable")&&($xname =~ "alias"))
    )
    {
      $adms_c.="void adms_${ename}_list_${xname}_prepend_once_or_abort (p_$ename mymy${ename},".ctype($_)." my${xname})\n";
      $adms_c.="{\n";
      $adms_c.="  p_slist list=mymy${ename}->_${xname};\n";
      $adms_c.="  while(list)\n";
      $adms_c.="  {\n";
      $adms_c.="    if(!adms_${xdatatypename}_cmp(adms_${xdatatypename}(list->data),my${xname}))\n";
      $adms_c.="    {\n";
      $adms_c.="      adms_message_fatal((\"${ename}=[%s] ${xname}=[%s] already defined\\n\",\n";
      $adms_c.="        adms_${ename}_uid(mymy${ename}),adms_${xdatatypename}_uid(my${xname})))\n";
      $adms_c.="      return;\n";
      $adms_c.="    }\n";
      $adms_c.="    list=list->next;\n";
      $adms_c.="  }\n";
      $adms_c.="  adms_slist_push(&mymy${ename}->_${xname},(p_adms)my$xname);\n";
      $adms_c.="}\n";
    }
    #lookup
    if(
      (($ename =~ "admsmain")&&($xname =~ "discipline"))
      ||
      (($ename =~ "admsmain")&&($xname =~ "module"))
      ||
      (($ename =~ "admsmain")&&($xname =~ "nature"))
      ||
      (($ename =~ "analogfunction")&&($xname =~ "variable"))
      ||
      (($ename =~ "module")&&($xname =~ "branchalias"))
      ||
      (($ename =~ "module")&&($xname =~ "node"))
      ||
      (($ename =~ "module")&&($xname =~ "variable"))
    )
    {
      $adms_c.=ctype($_)." adms_${ename}_list_${xname}_lookup_by_id (p_$ename mymy$ename,".&hdec($_).")\n";
      $adms_c.="{\n";
      $adms_c.="  p_slist list=mymy$ename->_$xname;\n";
      $adms_c.="  while(list) {\n";
      $adms_c.="    p_$xdatatypename ref$xdatatypename=adms_$xdatatypename(list->data);\n";
      $adms_c.="    if(";
      my@cmp;
      foreach(&uid($EH->{$xdatatypename}))
      {
        my$cur="ref$xdatatypename->_".&xname($_);
        my$ref="my".&xname($_);
        if(xdatatypename($_) eq "basicstring")
        {push @cmp,"!strcmp($cur,$ref)";}
        elsif(&xdatatypename($_) eq "lexval")
        {push @cmp,"!strcmp($cur->_string,$ref->_string)";}
        elsif(&xdatatypename($_) eq "quark")
        {push @cmp,"!strcmp($cur->_value,$ref->_value)";}
        elsif(&xdatatypename($_) eq "lexval")
        {push @cmp,"!strcmp($cur->_string,$ref->_string)";}
        else
        {push @cmp,"($cur==$ref)";}
      }
      $adms_c.=join "&&\n       ",@cmp;
      $adms_c.=")\n";
      $adms_c.="      return ref$xdatatypename;\n";
      $adms_c.="    list=list->next;\n";
      $adms_c.="  }\n";
      $adms_c.="  return NULL;\n";
      $adms_c.="}\n";
    }
  }
  next if $ename eq "adms";
  #new
  $adms_c.="p_$ename adms_${ename}_new(".&hdece($_).")\n";
  $adms_c.="{\n";
  $adms_c.="  p_$ename mynew$ename=(p_$ename) calloc(1,(size_t)sizeof(t_$ename));\n";
  $adms_c.="  adms_global_increment_nb${ename}new();\n" if($ename eq "admst");
  my$parent=&eparent($_);
  if($parent)
  {
    $adms_c.=&pnew($_,"mynew$ename->",$_,$parent);
  }
  foreach(&attr($_))
  {
    my$xname=&xname($_);
    my$xdatatypename=&xdatatypename($_);
    my$xdefault=&xdefault($_);
    if($_->parentNode->nodeName eq "uid")
    {
      if($xdatatypename eq "basicstring") {$adms_c.="  mynew$ename->_$xname=adms_kclone(my$xname);\n";}
      else                                {$adms_c.="  mynew$ename->_$xname=my$xname;\n";}
      $adms_c.="  mynew$ename->_${xname}_isdefault=1;\n" if vla($ename);
    }
    elsif(defined $xdefault)
    {
         if($xdatatypename eq "basicenumeration")     {$adms_c.="  mynew$ename->_$xname=admse_$xdefault;\n";}
      elsif($xdatatypename eq "basicinteger")         {$adms_c.="  mynew$ename->_$xname=$xdefault;\n"}
      elsif($xdatatypename eq "basicreal")            {$adms_c.="  mynew$ename->_$xname=$xdefault;\n"}
      elsif($xdatatypename eq "basicstring")          {$adms_c.="  mynew$ename->_$xname=adms_kclone(\"$xdefault\");\n";}
      elsif($xdatatypename eq "quark")                {$adms_c.="  mynew$ename->_$xname=adms_quark_new(\"$xdefault\");\n";}
      elsif($xdefault eq "")                          {$adms_c.="  mynew$ename->_$xname=NULL;\n";}
      $adms_c.="  mynew$ename->_${xname}_isdefault=1;\n" if vla($ename);
    }
    else
    {
      $adms_c.="  mynew$ename->_${xname}_isdefault=-1;\n" if vla($ename);
    }
  }
  $adms_c.="  return mynew$ename;\n";
  $adms_c.="}\n";
  $adms_c.=&mkuid($_);
  next if not vla($ename);
  #xnew
  my@inputs;
  my$i=0;
  my$check;
  my$free;
  my$nbinputs=scalar(@{uid($_)});
  $adms_c.="static p_admst adms_${ename}_xnew (p_ktransform mytransform,p_admst dot,p_slist myinputs[],const int size)\n{\n";
  $adms_c.="  if(size!=$nbinputs)\n";
  $adms_c.="  {\n";
  $adms_c.="    adms_message_fatal_continue((\"admst:new($ename) bad number of inputs (found %i, expected $nbinputs)\\n\",size))\n";
  $adms_c.="    adms_message_fatal((\"see %s\\n\",adms_transform_uid(mytransform)))\n";
  $adms_c.="    return NULL;\n";
  $adms_c.="  }\n";
  $adms_c.="  else\n";
  $adms_c.="  {\n";
  $adms_c.="    p_admst myadmst=adms_admst_new(dot);\n";
  $adms_c.="    p_$ename myadms;\n";
  foreach(&uid($_))
  {
    my$xname=&xname($_);
    my$xdatatypename=&xdatatypename($_);
    if(0) {}
    elsif($xdatatypename eq "basicinteger")
    {
      $adms_c.="    char* my${xname}s=aprintf(mytransform,(p_admst)myinputs[$i]->data);\n";
      $adms_c.="    ".ctype($_)." my$xname=adms_strtol(mytransform,my${xname}s);\n";
      $free.="    free(my${xname}s);\n";
    }
    elsif($xdatatypename eq "basicreal")
    {
      $adms_c.="    char* my${xname}s=aprintf(mytransform,(p_admst)myinputs[$i]->data);\n";
      $adms_c.="    ".ctype($_)." my$xname=adms_strtod(mytransform,my${xname}s);\n";
      $free.="    free(my${xname}s);\n";
    }
    elsif($xdatatypename eq "basicstring")
    {
      $adms_c.="    char* my${xname}=aprintf(mytransform,(p_admst)myinputs[$i]->data);\n";
      $free.="    free(my${xname});\n";
    }
    elsif($xdatatypename eq "basicenumeration")
    {
      $adms_c.="    char* my${xname}s=aprintf(mytransform,(p_admst)myinputs[$i]->data);\n";
      $adms_c.="    admse my${xname}e=ns_strtoe(my${xname}s);\n";
      $adms_c.="    ".ctype($_)." my$xname=my${xname}e;\n";
      $check.="    if(!my${xname}e)\n";
      $check.="    {\n";
      $check.="      adms_message_fatal_continue((\"cannot convert '%s' to a valid value\\n\",my${xname}s))\n";
      $check.="      adms_message_fatal((\"see %s\\n\",adms_transform_uid(mytransform)))\n";
      $check.="    }\n";
      $free.="    free(my${xname}s);\n";
    }
    elsif(xsize($_) eq "list")
    {
      $adms_c.="    ".ccontainer($_)." my$xname=myinputs[$i];\n";
    }
    elsif($xdatatypename eq "lexval")
    {
      $adms_c.="    char* my${xname}s=aprintf(mytransform,(p_admst)myinputs[$i]->data);\n";
      $adms_c.="    ".ctype($_)." my$xname=adms_lexval_new(my${xname}s,adms_transform_uid(mytransform),0,0);\n";
      $free.="    free(my${xname}s);\n";
    }
    elsif($xdatatypename eq "quark")
    {
      $adms_c.="    char* my${xname}s=aprintf(mytransform,(p_admst)myinputs[$i]->data);\n";
      $adms_c.="    ".ctype($_)." my$xname=adms_quark_new(my${xname}s);\n";
      $free.="    free(my${xname}s);\n";
    }
    else
    {
      $adms_c.="    ".ccontainer($_)." my$xname=adms_$xdatatypename(((p_admst)myinputs[$i]->data)->_item.p);\n";
      $free.="    deref((p_admst)myinputs[$i]->data);\n";
    }
    push @inputs,"my$xname";
    $i++;
  }
  $adms_c.=$check if $check;
  $adms_c.="    myadms=adms_${ename}_new(".(join",",@inputs).");\n";
  $adms_c.=$free if $free;
  $adms_c.="    myadmst->_item.p=(p_adms)myadms;\n";
  $adms_c.="    myadmst->_pseudo=admse_$ename;\n";
  $adms_c.="    return myadmst;\n";
  $adms_c.="  }\n";
  $adms_c.="}\n";
}

$adms_c.=q@
#undef VVA
#define VVA(e) else if(!strcmp(ename,#e)) return (p_new) adms_##e##_xnew;
p_new adms_admsxml_new (p_ktransform mytransform,const char* ename)
{
if(0) {}
VA
  else if(!strcmp(ename,"basicenumeration")) return (p_new) adms_basicenumeration_xnew;
  else if(!strcmp(ename,"basicinteger")) return (p_new) adms_basicinteger_xnew;
  else if(!strcmp(ename,"basicreal")) return (p_new) adms_basicreal_xnew;
  else if(!strcmp(ename,"basicstring")) return (p_new) adms_basicstring_xnew;
  adms_message_fatal_continue(("adms element '%s' cannot be created using admst:new\\n",ename))
  adms_message_fatal(("see %s\\n",adms_transform_uid(mytransform)))
  return NULL;
}
#undef VVA
#define VVA(e) if(myadmst->_pseudo==admse_##e) return (p_cmp)adms_##e##_cmp;
p_cmp adms_admsxml_cmp (p_kadmst myadmst)
{
  if(myadmst->_pseudo==admse_basicenumeration) return (p_cmp)adms_basicenumeration_cmp;
  if(myadmst->_pseudo==admse_basicinteger) return (p_cmp)adms_basicinteger_cmp;
  if(myadmst->_pseudo==admse_basicreal) return (p_cmp)adms_basicreal_cmp;
  if(myadmst->_pseudo==admse_basicstring) return (p_cmp)adms_basicstring_cmp;
VA
  adms_message_fatal_continue(("%s:%i: internal error - should not be reached\\n",__FILE__,__LINE__))
  adms_message_fatal(("%s:%i: please report to r29173\@users.sourceforge.net\\n",__FILE__,__LINE__))
  return NULL;
}
@;

#miscC
$adms_c.=q[
/*-- Miscellaneous routines --*/
int adms_strtol (p_ktransform mytransform,const char* mynumber)
{
  int nb;
  char* tail;
  errno=0;
  nb=strtol(mynumber,&tail,10);
  if(*tail||errno)
  {
    adms_message_fatal_continue(("%s: cannot convert value to valid integer value\n",mynumber))
    adms_message_fatal(("see %s\n",adms_transform_uid(mytransform)))
  }
  return nb;
}
double adms_strtod (p_ktransform mytransform,const char* myreal)
{
  double nb;
  char* tail;
  errno=0;
  nb=strtod(myreal,&tail);
  if(*tail||errno)
    return adms_NAN;
  if(*tail||errno)
  {
    adms_message_fatal_continue(("%s: cannot convert value to valid real value\n",myreal))
    adms_message_fatal(("see %s\n",adms_transform_uid(mytransform)))
  }
  return nb;
}
void bp(void) {}
char*adms_integertostring(int value)
{
   char*string=malloc(sizeof(char)*50);
   sprintf(string,"%i",value);
   return string;
}
char*adms_doubletostring(double value)
{
   if(isnan(value))
   {
     char*string=malloc(sizeof(char)*4);
     sprintf(string,"nan");
     return string;
   }
   else
   {
     char*string=malloc(sizeof(char)*50);
     sprintf(string,"%e",value);
     return string;
   }
}
int adms_file_isregular(const char* myfilename)
{
  return((access(myfilename,ADMS_F_OK)==0));
}
int adms_file_isdirectory(const char* myfilename)
{
  struct stat s;
  return((stat(myfilename,&s)==0)&&(s.st_mode&ADMS_S_IFDIR));
}
int adms_setenv(const char* myname,const char* myvalue)
{
  int myres;
#if defined(HAVE_PUTENV)
  char*myassign=NULL;
  adms_k2strconcat(&myassign,myname);
  adms_k2strconcat(&myassign,"=");
  adms_k2strconcat(&myassign,myvalue);
  myres=putenv(myassign);
  free(myassign);
#else
  myres=setenv(myname,myvalue,1);
#endif
  return (myres==0);
}
p_slist adms_slist_last (p_slist l)
{
  if(l)
  {
    while(l->next)
      l=l->next;
  }
  return l;
}
p_slist adms_slist_new (p_adms d)
{
  p_slist newl=NULL;
  adms_slist_push(&newl,d);
  return newl;
}
p_slist adms_slist_copy (p_slist l)
{
  p_slist copiedl=NULL;
  while(l)
  {
    adms_slist_push(&copiedl,l->data);
    l=l->next;
  }
  return adms_slist_reverse(copiedl);
}
void adms_slist_push(p_slist* l,p_adms data)
{
  p_slist n=malloc(sizeof(t_slist));
  n->next=*l;
  n->data=data;
  *l=n;
}
p_adms adms_slist_pull(p_slist* l)
{
  if(*l)
  {
    p_slist n=*l;
    p_adms data=n->data;
    *l=(*l)->next;
    free(n);
    return data;
  }
  return NULL;
}
void adms_slist_concat (p_slist* l1,p_slist l2)
{
  if(l2)
  {
    if(*l1)
      adms_slist_last(*l1)->next=l2;
    else
      *l1=l2;
  }
}
unsigned int adms_slist_length (p_slist l)
{
  unsigned int length=0;
  while(l)
  {
    length++;
    l=l->next;
  }
  return length;
}
p_slist adms_slist_nth (p_slist l,unsigned int  n)
{
  while (n-->0 && l)
    l=l->next;
  return l;
}
p_adms adms_slist_nth_data (p_slist l,unsigned int n)
{
  while (n-->0 && l)
    l=l->next;
  return l ? l->data : ((p_adms)0);
}
p_slist adms_slist_find (p_slist l,p_kadms data)
{
  while(l)
  {
    if(l->data==data)
      break;
    l=l->next;
  }
  return l;
}
int adms_slist_index (p_slist l, p_kadms data)
{
  int i=0;
  while(l)
  {
    if(l->data==data)
      return i;
    i++;
    l=l->next;
  }
  return -1;
}
p_slist adms_slist_reverse (p_slist l)
{
  p_slist p=NULL;
  while(l)
  {
    p_slist n=l->next;
    l->next=p;
    p=l;
    l=n;
  }
  return p;
}
void adms_slist_inreverse (p_slist* l)
{
  *l=adms_slist_reverse(*l);
}
void adms_slist_free (p_slist l)
{
  while(l)
  {
    p_slist freed=l;
    l=l->next;
    free(freed);
  }
}
int globalnbadmstnew=0, globalnbadmstdestroy=0;
int adms_global_nbadmstnew(void) {return globalnbadmstnew;}
int adms_global_nbadmstdestroy(void) {return globalnbadmstdestroy;}
void adms_global_increment_nbadmstnew(void) {globalnbadmstnew++;}
void adms_global_increment_nbadmstdestroy(void) {globalnbadmstdestroy++;}
p_admsmain globaladmsmain;
p_admsmain root(void) {return globaladmsmain;}
void rootnew(p_admsmain myglobaladmsmain) {globaladmsmain=myglobaladmsmain;}

/*-- Messaging --*/
void adms_toupper(char*m)
{
  for(;*m;m++)
    *m=toupper(*m);
}
void adms_tolower(char*m)
{
  for(;*m;m++)
    *m=tolower(*m);
}
char*adms_kclone(const char* m)
{
  if(m)
  {
    int l=strlen(m);
    char*mycpy=(char*)malloc((l+1)*sizeof(char));
    memcpy(mycpy,m,l);
    mycpy[l]='\0';
    return mycpy;
  }
  else
    return NULL;
}
char*adms_knclone(const char* m,const int l)
{
  char*mycpy=(char*)malloc((l+1)*sizeof(char));
  memcpy(mycpy,m,l);
  mycpy[l]='\0';
  return mycpy;
}
/*clone array (m,n(: "abcdefghijkl\0" returns as "cdef\0"*/
/*                      m   n                            */
/* same as adms_knclone(m,n-m)                           */
char*adms_m2nclone (const char* m,const char* n)
{
  int l=(char*)n-(char*)m;
  char*mycpy=(char*)malloc((l+1)*sizeof(char));
  memcpy(mycpy,m,l);
  mycpy[l]='\0';
  return mycpy;
}
/*s1: realloced s2: constant ret: s1=s1s2*/
void adms_k2strconcat (char **s1,const char* s2)
{
  if(!s2)
    return;
  if(*s1)
  {
    int l1=strlen(*s1);
    int l2=strlen(s2);
    *s1=(char*)realloc(*s1,(l1+l2+1)*sizeof(char));
    memcpy(*s1+l1,s2,l2+1);
  }
  else
    *s1=strdup(s2);
}
/*s1: realloced s2: freed ret: s1=s1s2*/
void adms_strconcat (char **s1,char *s2)
{
  adms_k2strconcat(s1,s2);
  free(s2);
}
FILE* adms_file_open_read (const char* myfilename)
{
  FILE* fh=fopen(myfilename,"r");
  if(!fh)
    adms_message_fatal(("%s: failed to open file [read mode]\n",myfilename))
  return fh;
}

];

foreach my$mess(@message)
{
my$name=$mess->[0];
my$ofh=$mess->[1];
my$isfatal=($mess->[2]==1);
my$iserror=($mess->[2]==2);
my$prefix=sprintf("\"[%-7s]",$name);
$prefix=~s/ /\./g;
$prefix.=" \"";
$adms_c.="_t_message (adms_message_${name}_impl)\n";
$adms_c.="{\n";
$adms_c.="  va_list ap;\n";
$adms_c.="  int insideformat=0;\n";
$adms_c.="  int i;\n";
$adms_c.="  char* s;\n";
$adms_c.="  double d;\n";
$adms_c.="  void* p;\n";
$adms_c.="  fputs($prefix,$ofh);\n" if($mess->[2]>=0);
$adms_c.="  va_start(ap, format);\n";
$adms_c.="  for(;*format;format++)\n";
$adms_c.="  {\n";
$adms_c.="    if(insideformat)\n";
$adms_c.="    {\n";
$adms_c.="      insideformat=0;\n";
$adms_c.="      switch(*format) \n";
$adms_c.="      {\n";
$adms_c.="        case 's':\n";
$adms_c.="          s=va_arg (ap,char*);\n";
$adms_c.="          if(s) fputs(s,$ofh); else fputs(\"NULL\",$ofh);\n";
$adms_c.="          break;\n";
$adms_c.="        case 'e':\n";
$adms_c.="          d=va_arg (ap,double);\n";
$adms_c.="          fprintf($ofh,\"%e\",d);\n";
$adms_c.="          break;\n";
$adms_c.="        case 'g':\n";
$adms_c.="          d=va_arg (ap,double);\n";
$adms_c.="          fprintf($ofh,\"%g\",d);\n";
$adms_c.="          break;\n";
$adms_c.="        case 'f':\n";
$adms_c.="          d=va_arg (ap,double);\n";
$adms_c.="          fprintf($ofh,\"%f\",d);\n";
$adms_c.="          break;\n";
$adms_c.="        case 'i':\n";
$adms_c.="          i=va_arg (ap,int);\n";
$adms_c.="          fprintf($ofh,\"%i\",i);\n";
$adms_c.="          break;\n";
$adms_c.="        case 'p':\n";
$adms_c.="          p=va_arg (ap,void*);\n";
$adms_c.="          fprintf($ofh,\"%p\",p);\n";
$adms_c.="          break;\n";
$adms_c.="        default:\n";
$adms_c.="          fputc(*format,$ofh);\n";
$adms_c.="      }\n";
$adms_c.="    }\n";
$adms_c.="    else\n";
$adms_c.="    {\n";
$adms_c.="      switch(*format) \n";
$adms_c.="      {\n";
$adms_c.="        case '%':\n";
$adms_c.="          insideformat=1;\n";
$adms_c.="          break;\n";
$adms_c.="        default:\n";
$adms_c.="          fputc(*format,$ofh);\n";
$adms_c.="      }\n";
$adms_c.="    }\n";
$adms_c.="  }\n";
$adms_c.="  va_end (ap);\n";
$adms_c.="  fflush($ofh);\n";
$adms_c.="  bp();\n" if($iserror);
$adms_c.="  bp(),exit(1);\n" if($isfatal);
$adms_c.="}\n";
$adms_c.="_t_message (adms_message_${name}_continue_impl)\n";
$adms_c.="{\n";
$adms_c.="  va_list ap;\n";
$adms_c.="  int insideformat=0;\n";
$adms_c.="  int i;\n";
$adms_c.="  char* s;\n";
$adms_c.="  double d;\n";
$adms_c.="  void* p;\n";
$adms_c.="  fputs($prefix,$ofh);\n" if($isfatal || $iserror);
$adms_c.="  va_start(ap, format);\n";
$adms_c.="  for(;*format;format++)\n";
$adms_c.="  {\n";
$adms_c.="    if(insideformat)\n";
$adms_c.="    {\n";
$adms_c.="      insideformat=0;\n";
$adms_c.="      switch(*format) \n";
$adms_c.="      {\n";
$adms_c.="        case 's':\n";
$adms_c.="          s=va_arg (ap,char*);\n";
$adms_c.="          if(s) fputs(s,$ofh); else fputs(\"NULL\",$ofh);\n";
$adms_c.="          break;\n";
$adms_c.="        case 'e':\n";
$adms_c.="          d=va_arg (ap,double);\n";
$adms_c.="          fprintf($ofh,\"%e\",d);\n";
$adms_c.="          break;\n";
$adms_c.="        case 'g':\n";
$adms_c.="          d=va_arg (ap,double);\n";
$adms_c.="          fprintf($ofh,\"%g\",d);\n";
$adms_c.="          break;\n";
$adms_c.="        case 'f':\n";
$adms_c.="          d=va_arg (ap,double);\n";
$adms_c.="          fprintf($ofh,\"%f\",d);\n";
$adms_c.="          break;\n";
$adms_c.="        case 'i':\n";
$adms_c.="          i=va_arg (ap,int);\n";
$adms_c.="          fprintf($ofh,\"%i\",i);\n";
$adms_c.="          break;\n";
$adms_c.="        case 'p':\n";
$adms_c.="          p=va_arg (ap,void*);\n";
$adms_c.="          fprintf($ofh,\"%p\",p);\n";
$adms_c.="          break;\n";
$adms_c.="        default:\n";
$adms_c.="          fputc(*format,$ofh);\n";
$adms_c.="      }\n";
$adms_c.="    }\n";
$adms_c.="    else\n";
$adms_c.="    {\n";
$adms_c.="      switch(*format) \n";
$adms_c.="      {\n";
$adms_c.="        case '%':\n";
$adms_c.="          insideformat=1;\n";
$adms_c.="          break;\n";
$adms_c.="        default:\n";
$adms_c.="          fputc(*format,$ofh);\n";
$adms_c.="      }\n";
$adms_c.="    }\n";
$adms_c.="  }\n";
$adms_c.="  va_end (ap);\n";
$adms_c.="  fflush($ofh);\n";
$adms_c.="}\n";
}

open FILE,">$top_srcdir/admsXml/adms.c"; print FILE $adms_c; close FILE;
print "$top_srcdir/admsXml/adms.c: created\n";

#apath language

map{my$e=$_;my$ename=&xname($e);
map{push @{$A{xname($_)}},[$e,$_] if (&xname($_) ne "datatypename");}
&attr($_) if vla($ename)||$ename eq "return"||$ename eq "math"||$ename eq "subexpression";} @$EA;

my@Location03;
foreach(@$EA)
{
  my$ename=&xname($_);
  next if not $ename eq "adms"||$ename eq "math"||$ename eq "subexpression";
  push @Location03,"  IFIDENT($ename)\n";
  foreach($_->findnodes(".//element"))
  {
    next if not vla(xname($_));
    push @Location03,"    MKscalar(".xname($_).",sub)\n";
  }
  push @Location03,"  ENDIFIDENT\n";
}
foreach(keys(%A))
{
  my($aname,$ee)=($_,$A{$_});
  push @Location03,"  IFIDENT($aname)\n";
  foreach(@$ee)
  {
    my($e,$a)=@$_;
    if(xsize($a) eq "list")
    {
      push @Location03,"    MKlist(".xname($e).",".xdatatypename($a).")\n";
    }
    else
    {
      push @Location03,"    MKscalar(".xname($e).",".xdatatypename($a).")\n";
    }
  }
  push @Location03,"  ENDIFIDENT\n";
}

open admstpath_c,">$top_srcdir/admsXml/admstpath.c";
print admstpath_c $BUILDER;

#sanity
print admstpath_c '
#define EXCLUDECHILD if(mytransform->_children)\
  adms_message_fatal(("  assert=no(child) failed - see %s\n",adms_transform_uid(mytransform))) 
#define REQUIRECHILD if(!mytransform->_children)\
  adms_message_fatal(("  assert=has(child) failed - see %s\n",adms_transform_uid(mytransform))) 
#define REQUIRE(type,item) if(!mytransform->_##type##item)\
  adms_message_fatal(("  assert=has(" #item ") failed - see %s\n",adms_transform_uid(mytransform))) 
#define WARN(type,item) if(!myskipversion) if(!mytransform->_##type##item)\
  adms_message_warning(("attribute \'" #item "\' missing - compatibility check skipped - see %s\n",adms_transform_uid(mytransform))) 
#define EXCLUDE(type,item) if(mytransform->_##type##item)\
  adms_message_fatal(("  assert=no(" #item ") failed - see %s\n",adms_transform_uid(mytransform))) 
#define OBSOLETE(obsolete,new) if(!strcmp(mytransform->_name,#obsolete))\
  adms_message_obsolete(("%s: please use "#new" instead\n",adms_transform_uid(mytransform))) 
int myskipversion=0;
static int is_admst (const char* name)
{
  return (((strlen(name)==5)&&!strncmp(name,"admst",5))||((strlen(name)>5)&&!strncmp(name,"admst:",6)));
}
';
print admstpath_c "static void dbxx (p_transform mytransform)\n"; 
print admstpath_c "{\n"; 
foreach($admstxml->findnodes("//transform"))
{
  my$tname=xname($_);
  foreach($_->findnodes(".//attribute|.//attribute-implied|.//attribute-warning"))
  {
    my$type=xtype($_);
    my$aname=$type.xname($_);
    print admstpath_c "  if(!strcmp(mytransform->_name,\"$tname\")&&mytransform->_$aname) db$type(mytransform->_$aname);\n";
  }
  foreach($_->findnodes(".//attribute-list"))
  {
    my$type=xtype($_);
    my$aname=$type.xname($_);
    print admstpath_c "  if(!strcmp(mytransform->_name,\"$tname\")&&mytransform->_$aname)\n";
    print admstpath_c "  {\n";
    print admstpath_c "    p_slist l=mytransform->_$aname;\n";
    print admstpath_c "    for(;l;l=l->next)\n";
    print admstpath_c "      db$type((p_$type)l->data);\n";
    print admstpath_c "  }\n";
  }
}
print admstpath_c "}\n"; 

print admstpath_c "static void postxx (p_transform mytransform)\n"; 
print admstpath_c "{\n"; 
foreach($admstxml->findnodes("//transform"))
{
  my$tname=xname($_);
  foreach($_->findnodes(".//attribute|.//attribute-implied|.//attribute-warning"))
  {
    my$type=xtype($_);
    my$aname=$type.xname($_);
    print admstpath_c "  if(!strcmp(mytransform->_name,\"$tname\")&&mytransform->_$aname) post$type(mytransform->_$aname);\n";
  }
  foreach($_->findnodes(".//attribute-list"))
  {
    my$type=xtype($_);
    my$aname=$type.xname($_);
    print admstpath_c "  if(!strcmp(mytransform->_name,\"$tname\")&&mytransform->_$aname)\n";
    print admstpath_c "  {\n";
    print admstpath_c "    p_slist l=mytransform->_$aname;\n";
    print admstpath_c "    for(;l;l=l->next)\n";
    print admstpath_c "      post$type((p_$type)l->data);\n";
    print admstpath_c "  }\n";
  }
}
print admstpath_c "}\n"; 

print admstpath_c 'static void sanity (p_transform mytransform)'."\n";
print admstpath_c '{'."\n";
print admstpath_c '  if(!is_admst(mytransform->_name)) { }'."\n";
foreach($admstxml->findnodes("//transform"))
{
  my$transform=$_;
  my@ids;
  foreach($transform->findnodes("obsolete"))
  {
    push @ids,"!strcmp(mytransform->_name,\"".xname($_)."\")";
  }
  push @ids,"!strcmp(mytransform->_name,\"".xname($transform)."\")";
  print admstpath_c "  else if(".(join "||",@ids).") { ";
  print admstpath_c "REQUIRECHILD " if(defined xhaschild($transform) && (xhaschild($transform) eq "yes")); 
  print admstpath_c "EXCLUDECHILD " if(defined xhaschild($transform) && (xhaschild($transform) eq "no")); 
  foreach($transform->findnodes("obsolete|warning|exclude|attribute"))
  {
    my$xnode=$_;
    if($xnode->nodeName eq "warning")
    {
      print admstpath_c "WARN(".xtype($_).",".xname($_).") ";
    }
    elsif($xnode->nodeName eq "attribute")
    {
      print admstpath_c "REQUIRE(".xtype($_).",".xname($_).") ";
    }
    elsif($xnode->nodeName eq "exclude")
    {
      print admstpath_c "EXCLUDE(".xtype($_).",".xname($_).") ";
    }
    elsif($xnode->nodeName eq "obsolete")
    {
      print admstpath_c "OBSOLETE(".xname($_).",".xname($transform).") ";
    }
  }
  print admstpath_c "}\n";
}
print admstpath_c '  else adms_message_fatal(("%s: unknown transform\n",adms_transform_uid(mytransform)))'."\n";
print admstpath_c '}'."\n";

foreach (@Location03)
{
  if(/MK\w+\((\w+),(\w+)\)/) {$e=$1;$d=$2;}
  if(/IFIDENT\((\w+)\)/)
  {
    $a=$1;
    print admstpath_c "void location030$a\(p_ptraverse p,p_path mypath,p_slist* olistptr,p_slist li)\n";
    print admstpath_c "{\n";
    print admstpath_c "  p_admst ai=(p_admst)li->data;\n";
    print admstpath_c "  admse e=ai->_pseudo;\n";
    foreach(@{$ALIAS{$a}})
    {
      my($ealias,$e)=@{$_};
      print admstpath_c "  if(e==admse_$ealias)\n";
      print admstpath_c "    e=admse_$e;\n";
    }
    print admstpath_c "  if(0) {}\n";
    foreach(@{$ALIASBIS{$a}})
    {
      my($e,$ealias,$aalias)=@{$_};
      my$attr=$EAH{$ealias}{$aalias};
      my$pseudo="admse_".&xdatatypename($attr);
      my$valueto="adms_${ealias}_valueto_$aalias";
      my$item="s=((p_$e)ai->_item.p)->_$ealias->_$aalias";
      print admstpath_c 
"  else if(e==admse_$e)
  {
    p_admst d0=adms_admst_new(ai);
    p_admst d1=adms_admst_new(d0);
    adms_slist_push(&p->_alladmst,(p_adms)d0);
    adms_slist_push(&p->_alladmst,(p_adms)d1);
    d0->_item.p=(p_adms)((p_$e)ai->_item.p)->_$ealias; d0->_pseudo=admse_$ealias; d0->_valueto=(void*)adms_${e}_valueto_$ealias;
    d1->_item.s=((p_$ealias)d0->_item.p)->_$aalias; d1->_pseudo=$pseudo; d1->_valueto=(void*)$valueto;
    adms_slist_push(olistptr,(p_adms)d1);
  }
";
    }
  }
  elsif(/MKlist/)
  {
    if($e eq "list" && $a eq "item") {$code="p_admst d=(p_admst)lii->data; adms_slist_push(olistptr,(p_adms)d); d->_refd++;";}
    elsif($d eq "basicstring")       {$code="NEW_PUSH d->_item.p=lii->data; d->_pseudo=admse_basicstring;";}
    else                             {$code="NEW_PUSH d->_item.p=lii->data; d->_pseudo=lii->data->_datatypename;";}
    print admstpath_c 
"  else if(e==admse_$e)
  {
    p_slist lii=((p_$e)ai->_item.p)->_$a;
    for(;lii;lii=lii->next)
    {
      $code
    }
  }
";
  }
  elsif(/MKscalar\(attribute,adms\)/)
  {
    print admstpath_c 
"  else if(e==admse_$e)
  {
    NEW_PUSH d->_item.p=ai->_item.p; d->_pseudo=admse__croix;
  }
";
  }
  elsif(/MKscalar/)
  {
    my$item;
    my$pseudo;
    my$valueto="adms_${e}_valueto_$a";
    if($d eq "sub")                 {$item="p=ai->_item.p";             $pseudo="admse_$a;";$valueto="NULL";}
    elsif($d eq "basicenumeration") {$item="i=((p_$e)ai->_item.p)->_$a";$pseudo="admse_$d;";}
    elsif($d eq "basicinteger")     {$item="i=((p_$e)ai->_item.p)->_$a";$pseudo="admse_$d;";}
    elsif($d eq "basicreal")        {$item="r=((p_$e)ai->_item.p)->_$a";$pseudo="admse_$d;";}
    elsif($d eq "basicstring")      {$item="s=((p_$e)ai->_item.p)->_$a";$pseudo="admse_$d;";}
    elsif(/MKscalar/)               {$item="p=(p_adms)((p_$e)(ai->_item.p))->_$a";$pseudo="d->_item.p?d->_item.p->_datatypename:admse_empty;";}
    print admstpath_c 
"  else if(e==admse_$e)
  {
    NEW_PUSH d->_item.$item; d->_pseudo=$pseudo d->_valueto=(void*)$valueto;
  }\n";
  }
  if(/ENDIFIDENT/)
  {
    print admstpath_c "  else\n";
    print admstpath_c "  {\n";
    print admstpath_c "    CLONE(ai)\n";
    print admstpath_c "    adms_message_error((\"%s: '$a' bad attribute\\n\",adms_transform_uid(p->_path->_transform)))\n";
    print admstpath_c "  }\n";
    print admstpath_c "}\n";
  }
}
print admstpath_c "\n";
foreach (@Location03)
{
  if(/MK\w+\((\w+),(\w+)\)/) {$e=$1;$d=$2;}
  if(/IFIDENT\((\w+)\)/)
  {
    $a=$1;
    print admstpath_c "void location031$a\(p_ptraverse p,p_path mypath,p_slist* olistptr,p_slist li)\n";
    print admstpath_c "{\n";
    print admstpath_c "  p_admst ai=(p_admst)li->data;\n";
    print admstpath_c "  admse e=ai->_pseudo;\n";
    foreach(@{$ALIAS{$a}})
    {
      my($ealias,$e)=@{$_};
      print admstpath_c "  if(e==admse_$ealias)\n";
      print admstpath_c "    e=admse_$e;\n";
    }
    print admstpath_c "  if(0) {}\n";
    foreach(@{$ALIASBIS{$a}})
    {
      my($e,$ealias,$aalias)=@{$_};
      my$attr=$EAH{$ealias}{$aalias};
      my$pseudo="admse_".&xdatatypename($attr);
      my$valueto="adms_${ealias}_valueto_$aalias";
      my$item="s=((p_$e)ai->_item.p)->_$ealias->_$aalias";
      print admstpath_c 
"  else if(e==admse_$e)
  {
    p_admst d0=adms_admst_new(ai);
    p_admst d1=adms_admst_new(d0);
    adms_slist_push(&p->_alladmst,(p_adms)d0);
    adms_slist_push(&p->_alladmst,(p_adms)d1);
    d0->_item.p=(p_adms)((p_$e)ai->_item.p)->_$ealias; d0->_pseudo=admse_$ealias; d0->_valueto=(void*)adms_${e}_valueto_$ealias;
    d1->_item.s=((p_$ealias)d0->_item.p)->_$aalias; d1->_pseudo=$pseudo; d1->_valueto=(void*)$valueto;
    adms_slist_push(olistptr,(p_adms)d1);
  }
";
    }
  }
  if(/MKlist/)
  {
    if($e eq "list" && $a eq "item") {$pseudo="admse__eelist";}
    else                             {$pseudo="admse__elist";}
    print admstpath_c 
"  else if(e==admse_$e)
  {
    NEW_PUSH d->_item.p=(p_adms)(((p_$e)ai->_item.p)->_$a); d->_pseudo=$pseudo; d->_valueto=(void*)adms_${e}_valueto_$a;
  }
";
  }
  elsif(/MKscalar\(attribute,adms\)/)
  {
    print admstpath_c 
"  else if(e==admse_$e)
  {
    NEW_PUSH d->_item.p=ai->_item.p; d->_pseudo=admse__croix;
  }
";
  }
  elsif(/MKscalar/)
  {
    my$item;
    my$pseudo;
    my$valueto="adms_${e}_valueto_$a";
    if($d eq "basicenumeration") { $item="d->_item.i=((p_$e)ai->_item.p)->_$a"; $pseudo="d->_pseudo=admse_$d;"; }
    elsif($d eq "basicinteger") { $item="d->_item.i=((p_$e)ai->_item.p)->_$a"; $pseudo="d->_pseudo=admse_$d;"; }
    elsif($d eq "basicreal") { $item="d->_item.r=((p_$e)ai->_item.p)->_$a"; $pseudo="d->_pseudo=admse_$d;"; }
    elsif($d eq "basicstring") { $item="d->_item.s=((p_$e)ai->_item.p)->_$a"; $pseudo="d->_pseudo=admse_$d;"; }
    elsif($d eq "sub") { $item="d->_item.p=ai->_item.p"; $pseudo="d->_pseudo=admse_$a;"; $valueto="NULL"; }
    elsif(/MKscalar/)
    {
      $item="d->_item.p=(p_adms)((p_$e)(ai->_item.p))->_$a";
      $pseudo="d->_pseudo=d->_item.p?d->_item.p->_datatypename:admse_empty;";
    }
    print admstpath_c 
"  else if(e==admse_$e)
  {
    NEW_PUSH $item; $pseudo d->_valueto=(void*)$valueto;
  }\n";
  }
  if(/ENDIFIDENT/)
  {
    print admstpath_c "  else\n";
    print admstpath_c "  {\n";
    print admstpath_c "    CLONE(ai)\n";
    print admstpath_c "    adms_message_error((\"%s: '$a' bad attribute\\n\",adms_transform_uid(p->_path->_transform)))\n";
    print admstpath_c "  }\n";
    print admstpath_c "}\n";
  }
}
print admstpath_c "\n";
my@Locationalias03;
foreach(@$EA)
{
  foreach($_->findnodes("alias"))
  {
    push @Locationalias03, &xname($_);
  }
  push @Locationalias03,xname(&eparent($_)) if &eparent($_);
  next if (not vla(xname($_))) && xname($_) ne "adms";
  foreach(&attr($_))
  {
    push @Locationalias03, &xname($_);
  }
}
sub uniq
{
  my@array=@_;
  my%seen;
  my@new;
  map{push @new, $_ if not $seen{$_};$seen{$_}=1;} @array;
  return @new;
}
@Locationalias03=&uniq(@Locationalias03);
print admstpath_c "static void attributecallback (p_path mypath0,p_slist npaths,p_slist npath)\n";
print admstpath_c "{\n";
print admstpath_c "  p_path mypath=(p_path)npath->data;\n";
print admstpath_c "  mypath->_keeplist=(mypath0->_keeplist&&(npath->next==NULL)&&(mypath->_condition==NULL))||mypath->_keeplist;\n";
print admstpath_c "  if(mypath->_callback==(void*)location04)\n";
print admstpath_c "  {\n";
print admstpath_c "    mypath->_callback=(mypath->_keeplist)?(void*)location041:(void*)location040;\n";
print admstpath_c "    mypath->_id=(mypath->_keeplist)?\"location041\":\"location040\";\n";
print admstpath_c "  }\n";
print admstpath_c "  else if(mypath->_callback==(void*)location05)\n";
print admstpath_c "  {\n";
print admstpath_c "    mypath->_callback=(mypath->_keeplist)?(void*)location051:(void*)location050;\n";
print admstpath_c "    mypath->_id=(mypath->_keeplist)?\"location051\":\"location050\";\n";
print admstpath_c "  }\n";
print admstpath_c "  else if(mypath->_callback==(void*)location03)\n";
print admstpath_c "  {\n";
  print admstpath_c "    if(0) {}\n";
foreach (@Locationalias03)
{
  print admstpath_c "    else if(mypath->_text->_admse==admse_$_)\n";
  print admstpath_c "    {\n";
  if($_ eq "datatypename")
  {
    print admstpath_c "      mypath->_callback=(void*)location03datatypename;\n";
    print admstpath_c "      mypath->_id=\"$_\";\n";
  }
  else
  {
    print admstpath_c "      mypath->_callback=(mypath->_keeplist)?(void*)location031$_:(void*)location030$_;\n";
    print admstpath_c "      mypath->_id=(mypath->_keeplist)?\"${_}1\":\"${_}0\";\n";
  }
  print admstpath_c "    }\n";
}
print admstpath_c "    else\n";
print admstpath_c "    {\n";
print admstpath_c "      adms_message_fatal_continue((\"element or attribute '%s' does not exist\\n\",mypath->_text->_value))\n";
print admstpath_c "      adms_message_fatal((\"see %s\\n\",adms_transform_uid(mypath->_transform)))\n";
print admstpath_c "    }\n";
print admstpath_c "  }\n";
print admstpath_c "}\n";
close admstpath_c;
print "$top_srcdir/admsXml/admstpath.c: created\n";

#dtd
open admstpath_dtd,">$top_srcdir/admsXml/admstpath.dtd";
my$dtd=q[
<?xml version="1.0" encoding="UTF-8"?>
<!-- Spec interne d'un chemin 'admstpath'. Validation: xmllint dbgp.xml -noout -postvalid -noblanks --> 
<!--
Fichier dbgp.xml
<?xml version="1.0"?>
<!--?xml-stylesheet type="text/xsl" href="admsstyle.xsl"?-->
<!DOCTYPE admstpath SYSTEM "admstpath.dtd">
<!-- Exemple de donnees 'admstpath' -->
<admstpath>
<!-- inserer ici les elements <p/> -->
</admstpath>
-->
<!ELEMENT admstpath (p+) >
];

print admstpath_dtd $dtd;
close admstpath_dtd;
print "$top_srcdir/admsXml/admstpath.dtd: created\n";

#apath
open admstpathYacc_y,">$top_srcdir/admsXml/admstpathYacc.y";
print admstpathYacc_y "$BUILDER
\%{
#include \"adms.h\"

extern void addptraverse (void);
extern void addmtraverse (void);
extern void multtimetraverse (void);
extern void multdivtraverse (void);
extern void unaryptraverse (void);
extern void unarymtraverse (void);
extern void incrptraverse (void);
extern void incrmtraverse (void);
extern void subptraverse (void);
extern void location00 (void);
extern void location01 (void);
extern void location02 (void);
extern void location03 (void);
extern void location03datatypename (void);
extern void location03dummy (void);
extern void location04 (void);
extern void location05 (void);
extern void location07 (void);
extern void location08 (void);
extern void location09 (void);
extern void location09p (void);
extern void location10 (void);
extern void location11 (void);
extern void location12 (void);
extern void location13 (void);
extern void location130 (void);
extern void location14 (void);
extern void location15 (void);
extern void location16 (void);
extern void location17 (void);
extern void location18 (void);
extern void location19 (void);
extern void location20 (void);
extern void location21 (void);
extern void location22 (void);
extern void location23 (void);
extern void location24 (void);
extern void location25 (void);
extern void location26 (void);
extern void location27 (void);
extern void root00 (void);
extern void expression01 (void);

#define YYLEX_PARAM mypparse
#define YYPARSE_PARAM mypparse
#define admstpatherror(msgid) admstpatherrorimpl(mypparse,msgid)

#define BASICSTRING \\
  char* mytvalue=adms_knclone(((p_pparse)mypparse)->_tkstart,((p_pparse)mypparse)->_tklen); \\
  p_text mytext=adms_text_new(((p_pparse)mypparse)->_transform,mytvalue); \\
  p_path ret=adms_path_new(((p_pparse)mypparse)->_transform,mytext); \\
  ret->_aname=adms_kclone(mytvalue); \\
  adms_slist_push(&(mytext->_token),new_basicstring(mytvalue)); \\
  fixtext(mytext);
#define KIDENT(kst) \\
   p_text mytext=adms_text_new(((p_pparse)mypparse)->_transform,kst); \\
   p_path ret=adms_path_new(((p_pparse)mypparse)->_transform,mytext); \\
   ret->_aname=adms_kclone(kst); \\
   adms_slist_push(&(mytext->_token),new_basicstring(kst)); \\
   fixtext(mytext);
#define INTEGER BASICSTRING
#define REAL BASICSTRING
#define IDENT BASICSTRING
#define PREVCTXT   adms_slist_pull(&globalctxt);
#define ISPATH     ((int)(long)globalctxt->data==0)
#define ISTIC      ((int)(long)globalctxt->data==2)
#define ISTEXT     ((int)(long)globalctxt->data==1)
#define SETPATH    adms_slist_push(&globalctxt,(p_adms)0);
#define SETTIC     adms_slist_push(&globalctxt,(p_adms)2);
#define SETTEXT    adms_slist_push(&globalctxt,(p_adms)1);
#define INCPAREN paren++;
#define DECPAREN paren--;
#define PARENMATCH (parenidx&&paren==(int)(long)parenidx->data)
#define INSIDEPATH (globalctxt&&(globalctxt->next)&&(((int)(long)globalctxt->next->data)==0))

static p_slist globalctxt=NULL;
static int goto_atext=0;
static int paren=0;
static p_slist parenidx=NULL;
static int globalignorequote=0;

static p_adms new_basicstring (char*txt)
{
  p_admst myadmst=adms_admst_new(NULL);
  myadmst->_item.s=txt;
  myadmst->_pseudo=admse_basicstring;
  return (p_adms)myadmst;
}

static void fixtext (p_text mytext)
{
  char *avalue=NULL;
  if((adms_slist_length(mytext->_token)==1)&&(mytext->_token->data->_datatypename==admse_path))
    mytext->_toptype=admse__path;
  else if((adms_slist_length(mytext->_token)==1)&&(mytext->_token->data->_datatypename==admse_admst))
  {
    avalue=((p_admst)mytext->_token->data)->_item.s;
    mytext->_toptype=admse__constant;
  }  
  else
    mytext->_toptype=admse__any;
  if(avalue&&(mytext->_admse=ns_strtoe(avalue)))
  {}
  else
    mytext->_admse=admse__any;
}
p_path pparse (p_transform mytransform,const char* aname,const char* avalue)
{
  p_path mypath;
  p_pparse mypparse=adms_pparse_new(mytransform,aname,avalue);
  goto_atext=0;
  SETPATH
  globalignorequote=0;
  if(*avalue)
  {
    mypparse->_position=avalue;
    admstpathparse (mypparse);
    mypath=mypparse->_path;
    mypath->_aname=adms_kclone(aname);

  }
  else
  {
    mypath=NULL;
    adms_message_fatal_continue((\"invalid path \\\"\%s\\\"\\n\",mypparse->_value))
    adms_message_fatal((\"see \%s\\n\",adms_transform_uid(mypparse->_transform)))
  }
  PREVCTXT
  adms_pparse_free(mypparse);
  return mypath;
}
p_text tparse (p_ktransform mytransform, const char* aname, const char* avalue)
{
  p_text mytext;
  if(!avalue)
    mytext=adms_text_new(mytransform,avalue);
  else if(*avalue=='\\0')
  {
    p_text mytext=adms_text_new(mytransform,avalue);
    adms_slist_push(&(mytext->_token),new_basicstring(adms_kclone(\"\")));
    return mytext;
  }
  else
  {
    p_pparse mypparse=adms_pparse_new(mytransform,aname,avalue);
    SETTIC
    goto_atext=1;
    globalignorequote=1;
    mypparse->_position=avalue;
    admstpathparse (mypparse);
    mytext=mypparse->_text;
    adms_pparse_free(mypparse);
    mytext->_value=adms_kclone(avalue);
    PREVCTXT
  }

  if((adms_slist_length(mytext->_token)==1)&&(mytext->_token->data->_datatypename==admse_path))
    mytext->_toptype=admse__path;
  else if(!strcmp(avalue,\"\%p\"))
    mytext->_toptype=admse__p;
  else if((adms_slist_length(mytext->_token)==1)&&(mytext->_token->data->_datatypename==admse_admst))
    mytext->_toptype=admse__constant;
  else
    mytext->_toptype=admse__any;
  if(!strcmp(avalue,\"\%s\"))
    mytext->_admse=admse__s;
  else if((mytext->_admse=ns_strtoe(avalue)))
  {}
  else
    mytext->_admse=admse__any;
  mytext->_aname=adms_kclone(aname);
  return mytext;
}
void dbtext (p_text mytext)
{
  p_slist li;
  adms_message_admstdbg_impl(\"<text aname=\\\"\%s\\\" v=\\\"\%s\\\" toptype=\\\"\%i\\\" admse=\\\"\%s\\\" length=\\\"\%i\\\">\",
    mytext->_aname,mytext->_value,mytext->_toptype,ns_etostr(mytext->_admse),adms_slist_length(mytext->_token));
  for(li=mytext->_token;li;li=li->next)
  {
    p_adms mytoken=li->data;
    if(mytoken->_datatypename==admse_path)
    {
      adms_message_admstdbg_impl(\"\%\%(\");
      dbpath((p_path)mytoken);
      adms_message_admstdbg_impl(\")\");
    }
    else if(mytoken->_datatypename==admse_text)
    {
      adms_message_admstdbg_impl(\"\$(\");
      dbtext((p_text)mytoken);
      adms_message_admstdbg_impl(\")\");
    }
    else if(mytoken->_datatypename==admse_admst)
      adms_message_admstdbg_impl(\"\%s\",((p_admst)mytoken)->_item.s);
  }
  adms_message_admstdbg_impl(\"</text>\");
}
void dbpath (p_path mypath)
{
  if(mypath->_text||mypath->_l||mypath->_r||mypath->_b||mypath->_condition)
  {
    p_slist li;
    int i=0;
    adms_message_admstdbg_impl(\"<\%s aname=\\\"%s\\\" keeplist=\\\"%i\\\">\",mypath->_id,mypath->_aname,mypath->_keeplist);
    if(mypath->_l)
    {
      adms_message_admstdbg_impl(\"<bar>\");
      for(li=mypath->_l;li;li=li->next,i++)
      {
        p_slist l=(p_slist)li->data;
        adms_message_admstdbg_impl(\"<slash index=\\\"%i\\\">\",i);
        for(;l;l=l->next)
          dbpath((p_path)l->data);
        adms_message_admstdbg_impl(\"</slash>\");
      }
      adms_message_admstdbg_impl(\"</bar>\");
    }
    for(li=mypath->_r;li;li=li->next)
      dbpath((p_path)li->data);
    if(mypath->_b)
    {
      adms_message_admstdbg_impl(\"<b>\");
      for(li=mypath->_b;li;li=li->next)
        dbpath((p_path)li->data);
      adms_message_admstdbg_impl(\"</b>\");
    }
    for(li=mypath->_condition;li;li=li->next)
      dbpath((p_path)li->data);
    if(mypath->_text)
      dbtext(mypath->_text);
    adms_message_admstdbg_impl(\"</\%s>\",mypath->_id);
  }
  else
    adms_message_admstdbg_impl(\"<\%s/>\",mypath->_id);
}

static void binaryand (const p_path mypath,p_admst myadmst)
{
  ((_p_cbcondition)((p_path)mypath->_b->data)->_callback)((p_path)mypath->_b->data,myadmst);
  if(myadmst->_istrue==admse_yes)
    ((_p_cbcondition)((p_path)mypath->_b->next->data)->_callback)((p_path)mypath->_b->next->data,myadmst);
}
static void binaryor (const p_path mypath,p_admst myadmst)
{
  ((_p_cbcondition)((p_path)mypath->_b->data)->_callback)((p_path)mypath->_b->data,myadmst);
  if(myadmst->_istrue==admse_no)
    ((_p_cbcondition)((p_path)mypath->_b->next->data)->_callback)((p_path)mypath->_b->next->data,myadmst);
}

static void atomic00 (const p_path mypath,p_admst myadmst)
{
  p_ptraverse p0=ptraverse(myadmst,(p_path)mypath->_r->data);
  int passed=(p0->_admst==NULL)||(p0->_admst->data==NULL)||(((p_admst)p0->_admst->data)->_item.p==NULL);
  myadmst->_istrue=passed?admse_yes:admse_no;
  free_ptraverse(p0);
}
static void atomic01 (const p_path mypath,p_admst myadmst)
{
  atomic00(mypath,myadmst);
  myadmst->_istrue=(myadmst->_istrue==admse_no)?admse_yes:admse_no;
}
#undef AALIAS
#define AALIAS(e,alias,newe,a) if(prev->_pseudo==admse_##e) if(mypath->_text->_admse==admse_##alias)\\
prev->_istrue=adms_##newe(prev->_item.p)->_##a##_isdefault?admse_yes:admse_no;
#undef EEAVA
#define EEAVA(e,a) if(prev->_pseudo==admse_##e) if(mypath->_text->_admse==admse_##a)\\
prev->_istrue=adms_##e(prev->_item.p)->_##a##_isdefault?admse_yes:admse_no;
static void atomic02 (p_kadmst prev,p_path mypath)
{
  ALIAS
  EAVA
}
static void atomic03 (const p_path mypath,p_admst myadmst)
{
  ((_p_cbcondition)((p_path)mypath->_r->data)->_callback)(((p_path)mypath->_r->data),myadmst);
}
static void unary00 (const p_path mypath,p_admst myadmst)
{
  ((_p_cbcondition)((p_path)mypath->_r->data)->_callback)(((p_path)mypath->_r->data),myadmst);
  myadmst->_istrue=(myadmst->_istrue==admse_no)?admse_yes:admse_no;
}
static void atomic05 (const p_path mypath,p_admst myadmst)
{
  myadmst->_istrue=admse_yes;
}
static void atomic06 (const p_path mypath,p_admst myadmst)
{
  myadmst->_istrue=admse_no;
}
static void atomic08 (const p_path mypath,p_admst myadmst)
{
  p_ptraverse p0;
  p_ptraverse p1;
  p_slist myl0;
  p_slist myl1;
  int passed;
  p_path root0=(p_path)mypath->_r->data;
  p_path root1=(p_path)mypath->_r->next->data;
  p_slist n000=(p_slist)root0->_l->data;
  p_slist n01=root0->_l->next;
  p_slist n001=n000->next;
  p_path l000=(p_path)n000->data;
  p_slist n100=(p_slist)root1->_l->data;
  p_slist n11=root1->_l->next;
  p_slist n101=n100->next;
  p_path l100=(p_path)n100->data;
  int isdatatypename0=(l000->_callback==(void*)location03datatypename)&&(n001==NULL)&&(n01==NULL);
  int isquotedstring1=(l100->_callback==(void*)location09)&&(n11==NULL)&&(n101==NULL)&&(n11==NULL);
  if(isdatatypename0 && isquotedstring1)
  {
    myadmst->_istrue=(myadmst->_item.p->_datatypename==l100->_text->_admse)?admse_yes:admse_no;
    return;
  }
  p0=ptraverse(myadmst,(p_path)mypath->_r->data);
  p1=ptraverse(myadmst,(p_path)mypath->_r->next->data);
  myl0=p0->_admst;
  myl1=p1->_admst;
  passed=1;
  if(adms_slist_length(myl0)!=adms_slist_length(myl1))
    passed=0;
  for(;myl0&&passed;myl0=myl0->next,myl1=myl1->next)
  {
    p_admst myadmst0=aread((p_admst)myl0->data);
    p_admst myadmst1=aread((p_admst)myl1->data);
    if(!myadmst0)
      passed=0;
    else if(myadmst0->_pseudo==admse_empty)
    {}
    else if(myadmst0->_pseudo==admse_datatypename)
    {
      char* mystring=aprintf(mypath->_transform,myadmst1);
      passed=(myadmst0->_item.i==ns_strtoe(mystring));
      free(mystring);
    }
    else if((myadmst0->_pseudo==admse_basicinteger)&&(myadmst1->_pseudo==admse_basicstring))
      passed=!strcmp(adms_integertostring(myadmst0->_item.i),myadmst1->_item.s);
    else if((myadmst0->_pseudo==admse_basicstring)&&(myadmst1->_pseudo==admse_basicinteger))
      passed=!strcmp(myadmst0->_item.s,adms_integertostring(myadmst1->_item.i));
    else if((myadmst0->_pseudo==admse_basicenumeration)&&(myadmst1->_pseudo==admse_basicstring))
      passed=!strcmp(ns_etostr(myadmst0->_item.i),myadmst1->_item.s);
    else if((myadmst0->_pseudo==admse_basicstring)&&(myadmst1->_pseudo==admse_basicenumeration))
      passed=!strcmp(myadmst0->_item.s,ns_etostr(myadmst1->_item.i));
    else if((myadmst0->_pseudo==admse_basicenumeration)&&(myadmst1->_pseudo==admse_basicinteger))
      passed=(myadmst0->_item.i==myadmst1->_item.i);
    else if((myadmst0->_pseudo==admse_basicinteger)&&(myadmst1->_pseudo==admse_basicenumeration))
      passed=(myadmst0->_item.i==myadmst1->_item.i);
    else if(myadmst0->_pseudo!=myadmst1->_pseudo)
      passed=0;
    else if(myadmst0->_pseudo==admse_basicenumeration)
      passed=(myadmst0->_item.i==myadmst1->_item.i);
    else if(myadmst0->_pseudo==admse_basicinteger)
      passed=(myadmst0->_item.i==myadmst1->_item.i);
    else if(myadmst0->_pseudo==admse_basicreal)
      passed=(myadmst0->_item.r>=myadmst1->_item.r-1.0e-307)&&(myadmst0->_item.r<=myadmst1->_item.r+1.0e-307);
    else if(myadmst0->_pseudo==admse_basicstring)
      passed=!strcmp(myadmst0->_item.s,myadmst1->_item.s);
    else
      passed=(myadmst0->_item.p==myadmst1->_item.p);
  }
  myadmst->_istrue=passed?admse_yes:admse_no;
  free_ptraverse(p0);
  free_ptraverse(p1);
}
static void atomic09 (const p_path mypath,p_admst myadmst)
{
  atomic08(mypath,myadmst);
  myadmst->_istrue=(myadmst->_istrue==admse_no)?admse_yes:admse_no;
}
static void atomic10 (p_path mypath,p_admst myadmst)
{
  p_ptraverse p0=ptraverse(myadmst,(p_path)mypath->_r->data);
  p_ptraverse p1=ptraverse(myadmst,(p_path)mypath->_r->next->data);
  p_slist myl0=p0->_admst;
  p_slist myl1=p1->_admst;
  int passed=1;
  if(adms_slist_length(myl0)!=adms_slist_length(myl1))
    passed=0;
  else
  {
    for(;myl0&&passed;myl0=myl0->next,myl1=myl1->next)
    {
      p_admst myadmst0=(p_admst)myl0->data;
      p_admst myadmst1=(p_admst)myl1->data;
      admse mytype0=myadmst0->_pseudo;
      admse mytype1=myadmst1->_pseudo;
      if((mytype0==admse_basicinteger)&&(mytype1==admse_basicinteger))
      {
        int myinteger0=myadmst0->_item.i;
        int myinteger1=myadmst1->_item.i;
        passed=(myinteger0<myinteger1);
      }
      else if((mytype0==admse_basicreal)&&(mytype1==admse_basicreal))
      {
        double myreal0=myadmst0->_item.r;
        double myreal1=myadmst1->_item.r;
        passed=(myreal0<myreal1);
      }
      else
        adms_message_fatal((\"%s: 'less than' - case not implemented - sorry!\\n\",adms_transform_uid(mypath->_transform)))
    }
  }
  myadmst->_istrue=passed?admse_yes:admse_no;
  free_ptraverse(p0);
  free_ptraverse(p1);
}
static void atomic11 (const p_path mypath,p_admst myadmst)
{
  p_ptraverse p0=ptraverse(myadmst,(p_path)mypath->_r->data);
  p_ptraverse p1=ptraverse(myadmst,(p_path)mypath->_r->next->data);
  p_slist myl0=p0->_admst;
  p_slist myl1=p1->_admst;
  int passed=1;
  if(adms_slist_length(myl0)!=adms_slist_length(myl1))
    passed=0;
  else
  {
    for(;myl0&&passed;myl0=myl0->next,myl1=myl1->next)
    {
      p_admst myadmst0=(p_admst)myl0->data;
      p_admst myadmst1=(p_admst)myl1->data;
      admse mytype0=myadmst0->_pseudo;
      admse mytype1=myadmst1->_pseudo;
      if((mytype0==admse_basicinteger)&&(mytype1==admse_basicinteger))
      {
        int myinteger0=myadmst0->_item.i;
        int myinteger1=myadmst1->_item.i;
        passed=(myinteger0>myinteger1);
      }
      else if((mytype0==admse_basicreal)&&(mytype1==admse_basicreal))
      {
        double myreal0=myadmst0->_item.r;
        double myreal1=myadmst1->_item.r;
        passed=(myreal0>myreal1);
      }
      else
        adms_message_fatal((\"%s: 'greater than' - case not implemented - sorry!\\n\",adms_transform_uid(mypath->_transform)))
    }
  }
  myadmst->_istrue=passed?admse_yes:admse_no;
  free_ptraverse(p0);
  free_ptraverse(p1);
}

#if defined (STANDALONE)
#define adms_transform_uid(txt) \"unknown\"
#endif

static void admstpatherrorimpl (const p_pparse mypparse,char const *s)
{
  adms_message_fatal_continue((\"\%s - invalid path \\\"\%s\\\"\\n\",s,mypparse->_value))
  adms_message_fatal((\"see \%s\\n\",adms_transform_uid(mypparse->_transform)))
}
static const char* tparsecb (p_pparse mypparse)
{
  const char* t=mypparse->_position;
  mypparse->_tkstart=t;
  if(0) {}
  else if(*t=='\\\''&&INSIDEPATH)
  {
    PREVCTXT
    t+=1, mypparse->_tkid=tktk_cquote;
  }
  else if(*t=='\%')
  {
    if(*(t+1)=='\\0')
      t+=1, mypparse->_tkid=tktk_anytext;
    else if(*(t+1)=='s')
      t+=2, mypparse->_tkid=tktk_percents;
    else if(*(t+1)=='\%')
    {
      mypparse->_tkstart=t+1;
      t+=2, mypparse->_tkid=tktk_anytext;
    }
    else if(*(t+1)=='(')
    {
      INCPAREN adms_slist_push(&parenidx,(p_adms)(long)paren); SETPATH
      mypparse->_tkstart=t+2;
      t+=2, mypparse->_tkid=tktk_percent;
    }
    else
      t+=2, mypparse->_tkid=tktk_anytext;
  }
  else if(*t=='\\\\')
  {
    if(*(t+1)=='\\0')
      t+=1, mypparse->_tkid=tktk_anytext;
    if(*(t+1)=='n')
      t+=2, mypparse->_tkid=tktk_cr;
    else if(*(t+1)=='r')
      t+=2, mypparse->_tkid=tktk_cr;
    else if(*(t+1)=='t')
      t+=2, mypparse->_tkid=tktk_tab;
    else
    {
      mypparse->_tkstart=t+1;
      t+=2, mypparse->_tkid=tktk_anytext;
    }
  }
  else if(*t=='\$')
  {
    if(*(t+1)=='\\0')
      t+=1, mypparse->_tkid=tktk_anytext;
    if(*(t+1)=='(')
    {
      INCPAREN adms_slist_push(&parenidx,(p_adms)(long)paren); SETTEXT
      mypparse->_tkstart=t+2;
      t+=2, mypparse->_tkid=tktk_dollarvariable;
    }
    else
    {
      mypparse->_tkstart=t+1;
      t++;
      while(*t&&(isalnum(*t)||*t=='_'))
        t++;
      mypparse->_tkid=tktk_kdollarvariable;
    }
  }
  else if(ISTEXT&&(*t==')'))
  {
    if(PARENMATCH)
    {
      t+=1, mypparse->_tkid=tktk_closeE, adms_slist_pull(&parenidx);
      PREVCTXT
    }
    else
      t+=1, mypparse->_tkid=tktk_anytext;
    DECPAREN
  }
  else
  {
    if(INSIDEPATH)
    {
      if(ISTEXT) while(*t&&(*t!=')')&&(*t!='\\0')&&(*t!='\%')&&(*t!='\\\\')&&(*t!='\$')&&(*t!='\\''))
      {
        if(*t=='(') INCPAREN
        t++;
      }
      else if(ISTIC) while(*t&&(*t!='\\0')&&(*t!='\%')&&(*t!='\\\\')&&(*t!='\$')&&(*t!='\\''))
      {
        t++;
      }
      else
        adms_message_fatal((\"%s:'%s' unexpected error in apath parser - please report to r29173\@users.sourceforge.net\\n\",adms_transform_uid(mypparse->_transform),mypparse->_value))
    }
    else
    {
      if(ISTEXT) while(*t&&(*t!=')')&&(*t!='\\0')&&(*t!='\%')&&(*t!='\\\\')&&(*t!='\$'))
      {
        if(*t=='(') INCPAREN
        t++;
      }
      else if(ISTIC) while(*t&&(*t!='\\0')&&(*t!='\%')&&(*t!='\\\\')&&(*t!='\$'))
      {
        t++;
      }
      else
        adms_message_fatal((\"%s:'%s' unexpected error in apath parser - please report to r29173\@users.sourceforge.net\\n\",adms_transform_uid(mypparse->_transform),mypparse->_value))
    }
    mypparse->_tkid=tktk_anytext;
  }
  mypparse->_tklen=(int)(long)(t-mypparse->_tkstart);
  return t;
}
";

#lexer
print admstpathYacc_y "static int admstpathlex (p_pparse mypparse)
{
  const char* t=mypparse->_position;
  const char* tstart;
  if(*t=='\\0')
    return 0;
  if(goto_atext)
  {
    goto_atext=0;
    return tktk_goto_atext;
  }
";
map {print admstpathYacc_y "  while(".xvalue($_).") t++;\n";} $admstpathxml->findnodes("//ignore");
print admstpathYacc_y "  tstart=t;
  if(!strncmp(t,\"\\\'%p\\'\",4)&&!isalpha(*(t+4)))
    t+=4, mypparse->_tkid=tktk_ticptr;
  else if(!ISPATH)
    t=tparsecb(mypparse);
";
foreach($admstpathxml->findnodes("//constant|//regexp"))
{
  if($_->nodeName eq "regexp")
  {
    print admstpathYacc_y $_->textContent;
  }
  elsif(xvalue($_)=~/\w$/)
  {
    my$len=length(xvalue($_));
    print admstpathYacc_y "  else if(!strncmp(t,\"".xvalue($_)."\",$len)&&!isalpha(*(t+$len)))\n";
    print admstpathYacc_y "    t+=$len, mypparse->_tkid=tktk_".xid($_).";\n";
  }
  else
  {
    my$len=length(xvalue($_));
    print admstpathYacc_y "  else if(!strncmp(t,\"".xvalue($_)."\",$len))\n";
    print admstpathYacc_y "    t+=$len, mypparse->_tkid=tktk_".xid($_).";\n";
  }
}
print admstpathYacc_y "  else
  {
    adms_message_fatal((\"%s: invalid path - unexpected character: %s\\n\",
    adms_transform_uid(mypparse->_transform),
    mypparse->_value))
  }
  mypparse->_position=t;
  return mypparse->_tkid;
}
";

print admstpathYacc_y "
%}
%token tktk_cr
%token tktk_lf
%token tktk_tab
%token tktk_percent
%token tktk_percents
%token tktk_ticptr
%token tktk_anytext
%token tktk_goto_atext
%token tktk_cquote

";

map{map{print admstpathYacc_y "\%token "."tktk_".$_."\n";} split " ", xid($_);} $admstpathxml->findnodes("//constant|//regexp");
map{print admstpathYacc_y "\%type <_".xret($_)."> ".xid($_)."\n" if defined xret($_);} $admstpathxml->findnodes("//productionset");
print admstpathYacc_y "
%union
{
p_slist _slist;
p_path _path;
p_text _text;
}
%%
";

sub semantic
{
  my$set=shift;
  my$production=shift;
  my$semantic="";
  my$regexpcounter;
  my$rootcounter=0;
  my$binarycounter=0;
  my$inode=0;
  my$T=" ";
  my$itemidx=1;
  if(xregexp($production))
  {
    $semantic.=$T."  ".xregexp($_)."\n";
  }
  foreach($production->findnodes("item"))
  {
    my$iproduction=$admstpathxml->findnodes("//productionset[\@id='".xlinkto($_)."']")->[0];
    my$constant=$admstpathxml->findnodes("//constant[\@id='".xlinkto($_)."']")->[0];
    my$curregexp=$admstpathxml->findnodes("//regexp[contains(\@id,'".xlinkto($_)."')]");
    if($iproduction&&(xid($iproduction) eq "location"))
    {
      $semantic.=$T."  p_".xret($iproduction)." ".xid($iproduction)."$inode=\$$itemidx;\n";
      $inode++;
    }
    elsif($iproduction&&(xid($iproduction) eq "pathroot_l"))
    {
      $rootcounter++ if xid($iproduction) eq "pathroot";
      $binarycounter++ if xid($iproduction) eq "binaryor";
      $inode++;
    }
    elsif($iproduction)
    {
      $rootcounter++ if xid($iproduction) eq "pathroot";
      $binarycounter++ if xid($iproduction) eq "binaryor";
      $semantic.=$T."  p_".xret($iproduction)." ".xid($iproduction)."$inode=\$$itemidx;\n";
      $inode++;
    }
    elsif(defined xret($production))
    {}
    elsif(defined xregexp($production))
    {}
    elsif(xid($set) eq "locationcondition")
    {}
    elsif($curregexp)
    {
      $regexpcounter++;
      $semantic.=$T."char* mytvalue=adms_knclone(((p_pparse)mypparse)->_tkstart,((p_pparse)mypparse)->_tklen);\n";
      $semantic.=$T."p_text mytext=adms_text_new(((p_pparse)mypparse)->_transform,mytvalue);\n";
    }
    $itemidx++;
  }
  $T.="  ";
  my$pindex=xid($production);
  my$id=$pindex<10?"0$pindex":"$pindex";
  my$regexp=$regexpcounter?"mytext":"NULL";
  if(xregexp($production))
  {
  }
  elsif(xret($production) && (xret($production) eq "var"))
  {
    $semantic.=$T.'p_text mytext=adms_text_new(((p_pparse)mypparse)->_transform,"$insidetext");'."\n";
    $semantic.=$T.'p_path ret=adms_path_new(((p_pparse)mypparse)->_transform,mytext);'."\n";
    $semantic.=$T.'mytext->_token=adms_slist_reverse(atext0);'."\n";
  }
  elsif((xid($set) eq "location")||(xid($set) eq "atomic"))
  {
    $semantic.=$T."p_path ret=adms_path_new(((p_pparse)mypparse)->_transform,$regexp);\n";
  }
  if((xid($set) eq "atomic"))
  {
    $semantic.=$T."ret->_callback=(void*)".xid($set)."$id;\n";
    $semantic.=$T."ret->_id=\"".xid($set)."$id\";\n";
  }
  if(xid($set) eq "root")
  {
    if($pindex == 0)
    {
    }
    elsif($pindex == 1)
    {
      $semantic.=$T.'p_text mytext=adms_text_new(((p_pparse)mypparse)->_transform,"");'."\n";
      $semantic.=$T.'mytext->_token=adms_slist_reverse(atext0);'."\n";
      $semantic.=$T.'((p_pparse)mypparse)->_text=mytext;'."\n";
    }
  }
  elsif(xid($set) eq "pathroot_l")
  {
    if($pindex == 0)    { $semantic.=$T.'((p_pparse)mypparse)->_path=pathroot0;'."\n"; }
    elsif($pindex == 1) { $semantic.=$T.'((p_pparse)mypparse)->_path=pathroot1;'."\n"; }
  }
  elsif(xid($set) eq "identifier")
  {
    $semantic.=$T.'IDENT'."\n";
    $semantic.=$T.'$$=ret;'."\n";
  }
  elsif(xid($set) eq "pathroot")
  {
    $semantic.=$T.'p_path ret=adms_path_new(((p_pparse)mypparse)->_transform,NULL);'."\n";
    $semantic.=$T.'adms_slist_inreverse(&pathbar0);'."\n";
    $semantic.=$T.'ret->_l=pathbar0;'."\n";
    $semantic.=$T.'ret->_callback=NULL;'."\n";
    $semantic.=$T.'ret->_id="path";'."\n";
    $semantic.=$T.'$$=ret;'."\n";
  }
  elsif(xid($set) eq "pathbar")
  {
    if($pindex == 0)
    {
      $semantic.=$T.'p_slist ret=NULL;'."\n";
      $semantic.=$T.'adms_slist_push(&ret,(p_adms)pathadd0);'."\n";
      $semantic.=$T.'$$=ret;'."\n";
    }
    elsif($pindex == 1)
    {
      $semantic.=$T.'adms_slist_push(&pathbar0,(p_adms)pathadd1);'."\n";
      $semantic.=$T.'$$=pathbar0;'."\n";
    }
  }
  elsif(xid($set) eq "pathadd")
  {
    if($pindex == 0)
    {
      $semantic.=$T.'$$=pathmult0;'."\n";
    }
    elsif($pindex == 1)
    {
      $semantic.=$T.'p_slist ret=NULL;'."\n";
      $semantic.=$T.'p_path addp=adms_path_new(((p_pparse)mypparse)->_transform,NULL);'."\n";
      $semantic.=$T.'addp->_callback=(void*)addptraverse;'."\n";
      $semantic.=$T.'addp->_id="addptraverse";'."\n";
      $semantic.=$T.'adms_slist_push(&addp->_l,(p_adms)pathmult1);'."\n";
      $semantic.=$T.'adms_slist_push(&addp->_l,(p_adms)pathadd0);'."\n";
      $semantic.=$T.'adms_slist_push(&ret,(p_adms)addp);'."\n";
      $semantic.=$T.'$$=ret;'."\n";
    }
    elsif($pindex == 2)
    {
      $semantic.=$T.'p_slist ret=NULL;'."\n";
      $semantic.=$T.'p_path addm=adms_path_new(((p_pparse)mypparse)->_transform,NULL);'."\n";
      $semantic.=$T.'addm->_callback=(void*)addmtraverse;'."\n";
      $semantic.=$T.'addm->_id="addmtraverse";'."\n";
      $semantic.=$T.'adms_slist_push(&addm->_l,(p_adms)pathmult1);'."\n";
      $semantic.=$T.'adms_slist_push(&addm->_l,(p_adms)pathadd0);'."\n";
      $semantic.=$T.'adms_slist_push(&ret,(p_adms)addm);'."\n";
      $semantic.=$T.'$$=ret;'."\n";
    }
  }
  elsif(xid($set) eq "pathmult")
  {
    if($pindex == 0)
    {
      $semantic.=$T.'$$=pathunary0;'."\n";
    }
    elsif($pindex == 1)
    {
      $semantic.=$T.'p_slist ret=NULL;'."\n";
      $semantic.=$T.'p_path multp=adms_path_new(((p_pparse)mypparse)->_transform,NULL);'."\n";
      $semantic.=$T.'multp->_callback=(void*)multtimetraverse;'."\n";
      $semantic.=$T.'multp->_id="multtimetraverse";'."\n";
      $semantic.=$T.'adms_slist_push(&multp->_l,(p_adms)pathunary1);'."\n";
      $semantic.=$T.'adms_slist_push(&multp->_l,(p_adms)pathmult0);'."\n";
      $semantic.=$T.'adms_slist_push(&ret,(p_adms)multp);'."\n";
      $semantic.=$T.'$$=ret;'."\n";
    }
    elsif($pindex == 2)
    {
      $semantic.=$T.'p_slist ret=NULL;'."\n";
      $semantic.=$T.'p_path multm=adms_path_new(((p_pparse)mypparse)->_transform,NULL);'."\n";
      $semantic.=$T.'multm->_callback=(void*)multdivtraverse;'."\n";
      $semantic.=$T.'multm->_id="multdivtraverse";'."\n";
      $semantic.=$T.'adms_slist_push(&multm->_l,(p_adms)pathunary1);'."\n";
      $semantic.=$T.'adms_slist_push(&multm->_l,(p_adms)pathmult0);'."\n";
      $semantic.=$T.'adms_slist_push(&ret,(p_adms)multm);'."\n";
      $semantic.=$T.'$$=ret;'."\n";
    }
  }
  elsif(xid($set) eq "pathunary")
  {
    if($pindex == 0)
    {
      $semantic.=$T.'$$=pathincr0;'."\n";
    }
    elsif($pindex == 1)
    {
      $semantic.=$T.'p_slist ret=NULL;'."\n";
      $semantic.=$T.'p_path unaryp=adms_path_new(((p_pparse)mypparse)->_transform,NULL);'."\n";
      $semantic.=$T.'unaryp->_callback=(void*)unaryptraverse;'."\n";
      $semantic.=$T.'unaryp->_id="unaryptraverse";'."\n";
      $semantic.=$T.'adms_slist_push(&unaryp->_l,(p_adms)pathincr0);'."\n";
      $semantic.=$T.'adms_slist_push(&ret,(p_adms)unaryp);'."\n";
      $semantic.=$T.'$$=ret;'."\n";
    }
    elsif($pindex == 2)
    {
      $semantic.=$T.'p_slist ret=NULL;'."\n";
      $semantic.=$T.'p_path unarym=adms_path_new(((p_pparse)mypparse)->_transform,NULL);'."\n";
      $semantic.=$T.'unarym->_callback=(void*)unarymtraverse;'."\n";
      $semantic.=$T.'unarym->_id="unarymtraverse";'."\n";
      $semantic.=$T.'adms_slist_push(&unarym->_l,(p_adms)pathincr0);'."\n";
      $semantic.=$T.'adms_slist_push(&ret,(p_adms)unarym);'."\n";
      $semantic.=$T.'$$=ret;'."\n";
    }
  }
  elsif(xid($set) eq "pathincr")
  {
    if($pindex == 0)
    {
      $semantic.=$T.'$$=pathsep00;'."\n";
    }
    elsif($pindex == 1)
    {
      $semantic.=$T.'p_slist ret=NULL;'."\n";
      $semantic.=$T.'p_path incrp=adms_path_new(((p_pparse)mypparse)->_transform,NULL);'."\n";
      $semantic.=$T.'p_path path0=(p_path)adms_slist_last(pathsep00)->data;'."\n";
      $semantic.=$T.'path0->_keeplist=1;'."\n";
      $semantic.=$T.'incrp->_callback=(void*)incrptraverse;'."\n";
      $semantic.=$T.'incrp->_id="incrptraverse";'."\n";
      $semantic.=$T.'adms_slist_push(&incrp->_l,(p_adms)pathsep00);'."\n";
      $semantic.=$T.'adms_slist_push(&ret,(p_adms)incrp);'."\n";
      $semantic.=$T.'$$=ret;'."\n";
    }
    elsif($pindex == 2)
    {
      $semantic.=$T.'p_slist ret=NULL;'."\n";
      $semantic.=$T.'p_path incrm=adms_path_new(((p_pparse)mypparse)->_transform,NULL);'."\n";
      $semantic.=$T.'p_path path0=(p_path)adms_slist_last(pathsep00)->data;'."\n";
      $semantic.=$T.'path0->_keeplist=1;'."\n";
      $semantic.=$T.'incrm->_callback=(void*)incrmtraverse;'."\n";
      $semantic.=$T.'incrm->_id="incrmtraverse";'."\n";
      $semantic.=$T.'adms_slist_push(&incrm->_l,(p_adms)pathsep00);'."\n";
      $semantic.=$T.'adms_slist_push(&ret,(p_adms)incrm);'."\n";
      $semantic.=$T.'$$=ret;'."\n";
    }
  }
  elsif(xid($set) eq "pathsep0")
  {

    if($pindex == 0)
    {
      $semantic.=$T.'adms_slist_inreverse(&pathsep0);'."\n";
      $semantic.=$T.'$$=pathsep0;'."\n";
    }
    elsif($pindex == 1)
    {
      $semantic.=$T.'adms_slist_inreverse(&pathsep0);'."\n";
      $semantic.=$T.'$$=pathsep0;'."\n";
    }
    elsif($pindex == 2)
    {
      $semantic.=$T.'p_slist ret=pathsep0;'."\n";
      $semantic.=$T.'p_path pathroot=adms_path_new(((p_pparse)mypparse)->_transform,NULL);'."\n";
      $semantic.=$T.'pathroot->_callback=(void*)root00;'."\n";
      $semantic.=$T.'pathroot->_id="root00";'."\n";
      $semantic.=$T.'adms_slist_inreverse(&ret);'."\n";
      $semantic.=$T.'adms_slist_push(&ret,(p_adms)pathroot);'."\n";
      $semantic.=$T.'$$=ret;'."\n";
    }
    elsif($pindex == 3)
    {
      $semantic.=$T.'p_slist ret=pathsep0;'."\n";
      $semantic.=$T.'p_path pathroot=adms_path_new(((p_pparse)mypparse)->_transform,NULL);'."\n";
      $semantic.=$T.'pathroot->_callback=(void*)root00;'."\n";
      $semantic.=$T.'pathroot->_id="root00";'."\n";
      $semantic.=$T.'adms_slist_inreverse(&ret);'."\n";
      $semantic.=$T.'adms_slist_push(&ret,(p_adms)pathroot);'."\n";
      $semantic.=$T.'$$=ret;'."\n";
    }
  }
  elsif(xid($set) eq "pathsep")
  {
    if($pindex == 0)
    {
      $semantic.=$T.'p_slist ret=NULL;'."\n";
      $semantic.=$T.'adms_slist_push(&ret,(p_adms)locationcondition0);'."\n";
      $semantic.=$T.'$$=ret;'."\n";
    }
    elsif($pindex == 1)
    {
      $semantic.=$T.'adms_slist_push(&pathsep0,(p_adms)locationcondition1);'."\n";
      $semantic.=$T.'$$=pathsep0;'."\n";
    }
  }
  elsif(xid($set) eq "locationcondition")
  {
    if($pindex == 0)
    {
      $semantic.=$T."if(condition1) adms_slist_push(&location0->_condition,(p_adms)condition1);\n";
      $semantic.=$T."\$\$=location0;\n";
    }
    elsif($pindex == 1)
    {
      $semantic.=$T."p_path location0=adms_path_new(((p_pparse)mypparse)->_transform,NULL);\n";
      $semantic.=$T."location0->_callback=(void*)location00;\n";
      $semantic.=$T."location0->_id=\"dot\";\n";
      $semantic.=$T."if(condition0) adms_slist_push(&location0->_condition,(p_adms)condition0);\n";
      $semantic.=$T."\$\$=location0;\n";
    }
    elsif($pindex == 2)
    {
      $semantic.=$T."\$\$=location0;\n";
    }
    elsif($pindex == 3)
    {
      $semantic.=$T."pathroot0->_callback=(void*)subptraverse;\n";
      $semantic.=$T.'$$=pathroot0;'."\n";
    }
  }
  elsif(xid($set) eq "location")
  {
    my$label=xlabel($production)?xlabel($production):xid($set).$id;
    if($pindex == 2)
    {
      $semantic.=$T.'p_path ret=identifier0;'."\n";
      $semantic.=$T.'adms_slist_push(&ret->_r,(p_adms)pathroot1);'."\n";
    }
    elsif($pindex == 3) #ident
    {
      $semantic.=$T."if((mytext->_admse==admse_past_name)||(mytext->_admse==admse_datatypefamily))\n";
      $semantic.=$T."{\n";
      $semantic.=$T."  ret->_callback=(void*)location03dummy;\n";
      $semantic.=$T."  ret->_id=\"dummy\";\n";
      $semantic.=$T."}\n";
      $semantic.=$T."else ret->_callback=(void*)location03;\n";
    }
    elsif($pindex == 300) #index
    {
      $semantic.=$T.'ret->_callback=(void*)location03;'."\n";
    }
    elsif($pindex == 6)
    {
      $semantic.=$T.'p_text mytext=adms_text_new(((p_pparse)mypparse)->_transform,"$insidetext");'."\n";
      $semantic.=$T.'p_path ret=adms_path_new(((p_pparse)mypparse)->_transform,mytext);'."\n";
      $semantic.=$T.'mytext->_token=adms_slist_reverse(atext0);'."\n";
    }
    elsif(($pindex == 9)||($pindex == 15)||($pindex == 26))
    {
      $semantic.=$T.'ret->_text=quotedstring0;'."\n";
    }
    elsif($pindex == 200) #ticptr
    {
      $semantic.=$T.'p_text mytext=adms_text_new(((p_pparse)mypparse)->_transform,"\'%p\'");'."\n";
      $semantic.=$T.'adms_slist_push(&(mytext->_token),new_basicstring(adms_kclone("%p")));'."\n";
      $semantic.=$T.'mytext->_toptype=admse__p;'."\n";
      $semantic.=$T.'ret->_text=mytext;'."\n";
      $semantic.=$T.'ret->_callback=(void*)location09p;'."\n";
      $semantic.=$T."ret->_id=\"$label\";\n";
    }
    elsif($rootcounter==1)
    {
      $semantic.=$T."adms_slist_push(&ret->_r,(p_adms)pathroot0);\n";
    }
    elsif($rootcounter==2)
    {
      $semantic.=$T."adms_slist_push(&ret->_r,(p_adms)pathroot1);\n";
      $semantic.=$T."adms_slist_push(&ret->_r,(p_adms)pathroot0);\n";
    }
    if(($pindex != 3)&&($pindex != 300)&&($pindex != 200)) #ident and ticptr
    {
      $semantic.=$T."ret->_callback=(void*)".xid($set)."$id;\n";
      $semantic.=$T."ret->_id=\"$label\";\n";
    }
    $semantic.=$T."\$\$=ret;\n";
  }
  elsif(xid($set) eq "quotedstring")
  {
    if($pindex == 0)
    {
      $semantic.=$T.'p_text mytext=adms_text_new(((p_pparse)mypparse)->_transform,"qtext");'."\n";
      $semantic.=$T.'mytext->_token=adms_slist_reverse(atext0);'."\n";
      $semantic.=$T.'fixtext(mytext);'."\n";
      $semantic.=$T.'$$=mytext;'."\n";
    }
    elsif($pindex == 1)
    {
      $semantic.=$T.'p_text mytext=adms_text_new(((p_pparse)mypparse)->_transform,"");'."\n";
      $semantic.=$T.'adms_slist_push(&(mytext->_token),new_basicstring(adms_kclone("")));'."\n";
      $semantic.=$T.'$$=mytext;'."\n";
    }
  }
  elsif(xid($set) eq "atext")
  {
    if($pindex == 0)
    {
      $semantic.=$T.'p_slist token=NULL;'."\n";
      $semantic.=$T.'adms_slist_push(&token,(p_adms)atextitem0);'."\n";
      $semantic.=$T.'$$=token;'."\n";
    }
    elsif($pindex == 1)
    {
      $semantic.=$T.'adms_slist_push(&atext0,(p_adms)atextitem1);'."\n";
      $semantic.=$T.'$$=atext0;'."\n";
    }
  }
  elsif(xid($set) eq "atextitem")
  {
    if($pindex == 0)
    {
      $semantic.=$T.'$$=(p_path)new_basicstring(adms_kclone("\n"));'."\n";
    }
    elsif($pindex == 1)
    {
      $semantic.=$T.'$$=(p_path)new_basicstring(adms_kclone("\r"));'."\n";
    }
    elsif($pindex == 2)
    {
      $semantic.=$T.'$$=(p_path)new_basicstring(adms_kclone("\t"));'."\n";
    }
    elsif($pindex == 3)
    {
      $semantic.=$T.'char* mytvalue=adms_knclone(((p_pparse)mypparse)->_tkstart,((p_pparse)mypparse)->_tklen);'."\n";
      $semantic.=$T.'$$=(p_path)new_basicstring(mytvalue);'."\n";
    }
    elsif($pindex == 4)
    {
      $semantic.=$T.'p_text mys=adms_text_new(((p_pparse)mypparse)->_transform,"%s");'."\n";
      $semantic.=$T.'mys->_admse=admse__s;'."\n";
      $semantic.=$T.'$$=(p_path)(p_adms)mys;'."\n";
    }
    elsif($pindex == 5)
    {
      $semantic.=$T.'$$=pathroot0;'."\n";
    }
    elsif($pindex == 6)
    {
      $semantic.=$T.'p_text mytext=adms_text_new(((p_pparse)mypparse)->_transform,"$insidetext");'."\n";
      $semantic.=$T.'mytext->_token=adms_slist_reverse(atext0);'."\n";
      $semantic.=$T.'$$=(p_path)mytext;'."\n";
    }
    elsif($pindex == 7)
    {
      $semantic.=$T.'char* mytvalue=adms_knclone(((p_pparse)mypparse)->_tkstart,((p_pparse)mypparse)->_tklen);'."\n";
      $semantic.=$T.'p_text mytext=adms_text_new(((p_pparse)mypparse)->_transform,mytvalue);'."\n";
      $semantic.=$T.'adms_slist_push(&(mytext->_token),new_basicstring(mytvalue));'."\n";
      $semantic.=$T.'$$=(p_path)mytext;'."\n";
    }
  }
  elsif(xid($set) eq "condition")
  {
    $semantic.=$T."\$\$=expression0;\n";
  }
  elsif(xid($set) eq "expression")
  {
    if($pindex == 0)
    {
      $semantic.=$T.'$$=binaryor0;'."\n";
    }
    elsif($pindex == 1)
    {
      $semantic.=$T.'p_path ret=adms_path_new(((p_pparse)mypparse)->_transform,NULL);'."\n";
      $semantic.=$T.'ret->_callback=(void*)expression01;'."\n";
      $semantic.=$T.'ret->_id="expression01";'."\n";
      $semantic.=$T.'adms_slist_push(&ret->_r,(p_adms)pathroot0);'."\n";
      $semantic.=$T.'$$=ret;'."\n";
    }
  }
  elsif(xid($set) eq "binaryor")
  {
    if($pindex == 0)
    {
      $semantic.=$T.'$$=binaryand0;'."\n";
    }
    elsif($pindex == 1)
    {
      $semantic.=$T.'$$=adms_path_new(((p_pparse)mypparse)->_transform,NULL);'."\n";
      $semantic.=$T.'$$->_callback=(void*)binaryor;'."\n";
      $semantic.=$T.'$$->_id="or";'."\n";
      $semantic.=$T.'adms_slist_push(&$$->_b,(p_adms)binaryand1);'."\n";
      $semantic.=$T.'adms_slist_push(&$$->_b,(p_adms)binaryor0);'."\n";
    }
  }
  elsif(xid($set) eq "binaryand")
  {
    if($pindex == 0)
    {
      $semantic.=$T.'$$=unary0;'."\n";
    }
    elsif($pindex == 1)
    {
      $semantic.=$T.'$$=adms_path_new(((p_pparse)mypparse)->_transform,NULL);'."\n";
      $semantic.=$T.'$$->_callback=(void*)binaryand;'."\n";
      $semantic.=$T.'$$->_id="and";'."\n";
      $semantic.=$T.'adms_slist_push(&$$->_b,(p_adms)unary1);'."\n";
      $semantic.=$T.'adms_slist_push(&$$->_b,(p_adms)binaryand0);'."\n";
    }
  }
  elsif(xid($set) eq "unary")
  {
    if($pindex == 0)
    {
      $semantic.=$T.'$$=atomic0;'."\n";
    }
    elsif($pindex == 1)
    {
      $semantic.=$T.'p_path ret=adms_path_new(((p_pparse)mypparse)->_transform,NULL);'."\n";
      $semantic.=$T.'ret->_callback=(void*)unary00;'."\n";
      $semantic.=$T.'ret->_id="unary00";'."\n";
      $semantic.=$T.'adms_slist_push(&ret->_r,(p_adms)atomic0);'."\n";
      $semantic.=$T.'$$=ret;'."\n";
    }
  }
  elsif(xid($set) eq "atomic")
  {
    if($rootcounter==1)
    {
      $semantic.=$T."adms_slist_push(&ret->_r,(p_adms)pathroot0);\n";
    }
    elsif($rootcounter==2)
    {
      $semantic.=$T."adms_slist_push(&ret->_r,(p_adms)pathroot1);\n";
      $semantic.=$T."adms_slist_push(&ret->_r,(p_adms)pathroot0);\n";
    }
    elsif($binarycounter==1)
    {
      $semantic.=$T."adms_slist_push(&ret->_r,(p_adms)binaryor0);\n";
    }
    $semantic.=$T."\$\$=ret;\n";
  }
  return $semantic;
}
foreach($admstpathxml->findnodes("//productionset"))
{
  my$set=$_;
  print admstpathYacc_y xid($set)."\n";
  my$pindex=0;
  foreach($set->findnodes("production"))
  {
    print admstpathYacc_y (($pindex==0)?" :":" |");
    foreach($_->findnodes("item"))
    {
      my$production=$admstpathxml->findnodes("//productionset[\@id='".xlinkto($_)."']")->[0];
      print admstpathYacc_y " ".($production?xid($production):"tktk_".xlinkto($_));
    }
    print admstpathYacc_y "\n";
    print admstpathYacc_y " {/*$pindex*/\n";
    print admstpathYacc_y &semantic($set,$_);
    print admstpathYacc_y " }\n";
    $pindex++;
  }
  if($set->findnodes("empty"))
  {
    print admstpathYacc_y " |\n";
    print admstpathYacc_y " {/*$pindex*/\n";
    print admstpathYacc_y "   \$\$=NULL;\n";
    print admstpathYacc_y " }\n";
  }
  print admstpathYacc_y ";\n";
}
print admstpathYacc_y '
%%
#if defined (STANDALONE)
int main (int argc,char **argv)
{
  int argci;
  int doatext;
  char*aname="select";
  char*avalue=(argc==1)?"a/b/c|c|c|c":argv[1];
  p_pparse mypparse=adms_pparse_new(NULL,aname,avalue);
  for(argci=1;argci<argc;argci++)
  {
    admstpathdebug=admstpathdebug||!strcmp("-d",argv[argci]);
    doatext=doatext||!strcmp("-t",argv[argci]);
  }
  if(admstpathdebug) printf("debug=1\n");
  if(doatext) printf("text=1\n");
  goto_atext=doatext;
  printf("%s \"%s\"\n",argv[0],avalue);
  rootnew(adms_admsmain_new("admsmain"));
  mypparse->_position=avalue;
  if(doatext)
  {
    SETTIC
    globalignorequote=1;
    admstpathparse (mypparse);
    dbtext(mypparse->_text);
  }
  else
  {
    SETPATH
    globalignorequote=0;
    admstpathparse (mypparse);
    printf("<p id=\"%s\">",avalue);
    mypparse->_path->_aname=adms_kclone(aname);
    postpath(mypparse->_path);
    dbpath(mypparse->_path);
    printf("</p>\n");
  }
  return 0;
}
#endif
';
close admstpathYacc_y;
print "$top_srcdir/admsXml/admstpathYacc.y: created\n";

